/******************************************************************************
Name    :   more_threads.cpp
Author  :   John Q Metro
Purpose :   Single source category base thread classes
Created :   December 14, 2013
Updated :   December 14, 2013
******************************************************************************/
#ifndef MORE_THREADS_H_INCLUDED
  #include "more_threads.h"
#endif // MORE_THREADS_H_INCLUDED
//----------------------------------------------
/*****************************************************************************/
// constructor
jfSingleSearchThreadBase::jfSingleSearchThreadBase():jfDownloadThread() {
  search_results = NULL;
  main_search = NULL;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++
// setting search info
bool jfSingleSearchThreadBase::SetResultsStore(jfResultCollection* in_results) {
  search_results = in_results;
  if (in_results==NULL) return false;
  main_search = search_results->GetSearch();
  return true;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool jfSingleSearchThreadBase::CheckParams() const {
  if (dconst==NULL) return false;
  if (dconst->pauselink==NULL) return false;
  if (main_search==NULL) return false;
  if (search_results==NULL) return false;
  return true;
}
//===========================================================================
// constructor
jfSingleSearchThread::jfSingleSearchThread():jfSingleSearchThreadBase() {}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++
// some of the 'plug-in' virtual methods are implemented here
//---------------------------------------
void jfSingleSearchThread::SetUrl() {
  fetchurl = main_search->GetIndexUrl(pageindex);
}
//---------------------------------------
size_t jfSingleSearchThread::NewPagecount() const {
  return search_results->PageTotal();
}
/*****************************************************************************/
