/******************************************************************************
Name    :   more_threads.h
Author  :   John Q Metro
Purpose :   Single source category base thread classes
Created :   December 14, 2013
Updated :   December 21, 2013
******************************************************************************/
#ifndef MORE_THREADS_H_INCLUDED
#define MORE_THREADS_H_INCLUDED
#endif // MORE_THREADS_H_INCLUDED
//----------------------------------------------
#ifndef CORE_THREADS_H_INCLUDED
  #include "core_threads.h"
#endif // CORE_THREADS_H_INCLUDED
#ifndef RESULTCOLLECT_H_INCLUDED
  #include "../core/structs/resultcollect.h"
#endif // RESULTCOLLECT_H_INCLUDED
/*****************************************************************************/
// one source cateory search thread
class jfSingleSearchThreadBase : public jfDownloadThread {
  public:
    // constructor
    jfSingleSearchThreadBase();
    // a reminder
    virtual wxThread::ExitCode Entry() = 0;
    // setting data
    bool SetResultsStore(jfResultCollection* in_results);
  protected:
    // special
    bool CheckParams() const;
    // virtual plug-in methods to handle some vital bits
    virtual void PreFetch1() = 0;
    virtual void PreFetch2() = 0;
    virtual void SetUrl() = 0;
    virtual bool ProcessPage() = 0;
    virtual size_t NewPagecount() const = 0;
    // search data
    jfResultCollection* search_results;
    jfSearchCore* main_search;
};
//================================================================================
/* One source category search thread - assuming conventional search */
class jfSingleSearchThread : public jfSingleSearchThreadBase {
  public:
    // constructor
    jfSingleSearchThread();
    // a reminder
    virtual wxThread::ExitCode Entry() = 0;
  protected:
    // virtual plug-in methods to handle some vital bits
    virtual void PreFetch1() = 0;
    virtual void PreFetch2() = 0;
    virtual void SetUrl();
    virtual bool ProcessPage() = 0;
    virtual size_t NewPagecount() const;

};
/*****************************************************************************/
