/////////////////////////////////////////////////////////////////////////////
// Name:        filter_groups.h
// Author :     John Q Metro
// Purpose :    Declares global filter map groupings and associated stuff
// Created:     01.08.06
// Updated:     Febuary 19, 2012
/////////////////////////////////////////////////////////////////////////////

// ----------------------------------------------------------------------------
// headers
// ----------------------------------------------------------------------------
// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

// for all others, include the necessary headers
#ifndef WX_PRECOMP

#endif
// ----------------------------------------------------------------------------
#include <map>
#define JFILTERGROUPS

#ifndef BASECOLLECT_H_INCLUDED
  #include "../../structs/basecollect.h"
#endif // BASECOLLECT_H_INCLUDED

#ifndef JFBASEFILTER
  #include "filterbase.h"
#endif
#ifndef JFMOREBASE
  #include "morebase.h"
#endif
//*****************************************************************************
// forward declarations
class jfMapOfFiltermaps;
//============================================================================
jfBaseFilter* MakeFilter(const wxString& typestring, const wxString& newname);
//===========================================================================
// the following class serves as a sort of pointer for a specific filter,
// as well as it's context
class jfFilterPointer : public wxObject{
  friend class jfMapOfFiltermaps;
  public:
    jfBaseFilter* filter;
    // public methods
    wxString GetMapName() const;
    bool CheckForName(const wxString& fname) const;
    bool RenameElem(const wxString& newname);
  protected:
    jfFilterMap* filtermap;
    jfMapOfFiltermaps* mapomaps;
};
//============================================================================
// the array of filter types
class jfMapOfFiltermaps : public std::map<wxString,jfFilterMap*,ltstr> {
  public:
    // info methods
    bool NameExists(const wxString& mapname) const;
    jfFilterPointer* GetPointer(const wxString& mapname, const wxString& filtername);
    wxArrayString* GetMapNames() const;
    // some other special methods
    bool FindMapIndex(const wxString& mapname, size_t& newindex) const;
    bool RenameMap(const wxString& oldname, const wxString& newname, size_t& newindex);
    //file i/o
    void WriteToFile(const wxString& filename) const;
    bool ReadFromFile(const wxString& filename);
    // finishing
    int EmptyMaps();
  protected:
};



/////////////////////////////////////////////////////////////////////////////
