/////////////////////////////////////////////////////////////////////////////
// Name:        jaffis_morebase.h
// Author :     John Q Metro
// Purpose :    Declares extra filters that work on BasePD
// Created:     31.12.06
// Updated:     August 22, 2012 (adding parse_error)
/////////////////////////////////////////////////////////////////////////////

// ----------------------------------------------------------------------------
// headers
// ----------------------------------------------------------------------------
// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

// for all others, include the necessary headers
#ifndef WX_PRECOMP

#endif
// ----------------------------------------------------------------------------
#ifndef JFBASEFILTER
  #include "filterbase.h"
#endif
#ifndef JFEXPRSTRUCTS
  #include "../../express/expr_structs.h"
#endif
#define JFMOREBASE
//****************************************************************************
extern size_t efcounter;
extern const wxString EXP_FIL_TAG;
//-----------------------------------------------------------------------------
// the expression filter: a complicated filter indeed, which holds a boolean expression
// the operands of the expression, which can evaluate to true or false, are
// either string matching/searching, or other filters, embedded or linked.
class jfExpressionFilter : public jfBaseFilter {
  public:
    wxString parse_error;
    // the constructors
    jfExpressionFilter();
    jfExpressionFilter(const jfExpressionFilter& source,jfFilterMap* infmap_link);
    // redefined virtual functions
    virtual bool IsEmpty() const;
    bool SetFiltermapLink(jfFilterMap* infmap_link);
    bool FromString(const wxString& sourcedata);
    virtual wxString ToString() const;
    virtual jfExpressionFilter* Copy() const;
    virtual jfBaseFilter* GenCopy() const;
    // basic constants
    virtual wxString GetTypeID() const;
    virtual wxString GetTypeDescription() const;
    // modifying and checking the contents
    virtual bool VerifyNames(jfNameVerif* nameobj, bool notinmap);
    virtual bool VerifyNames(jfNameVerif* nameobj, const wxString& inmapname);
    bool CopyLoad();
    wxString MakePList() const;
    // special functions
    void EmptyFilter();
    // the destructor
    ~jfExpressionFilter();
  protected:
    // private methods
    virtual bool CoreMatch(const jfBasePD* testelem) const;
    virtual void SetValid();
    virtual size_t ExtraLines() const;
    virtual bool AddRestToFile(wxTextFile* outfile) const;
    virtual bool ReadRestFromFile(jfFileReader* infile);
    // private data
    wxString srcstring;
    jfElemArray* parsedinfo;
    bool loaded;
    // filter map link
    jfFilterMap* fmap_link;
};

///////////////////////////////////////////////////////////////////////////////
