//*****************************************************************************
// Name:        coretypes.cpp
// Author :     John Q Metro
// Purpose :    Decfines some core data holding types
// Created:     June 9, 2010
// Updated:     January 19, 2011
//*****************************************************************************
#ifndef JF_CORETYPES
  #include "coretypes.h"
#endif
//*****************************************************************************
// the constructor
Set32::Set32() { marks = 0; }
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// info methods
//-----------------------------------------------
bool Set32::IsMarked(const size_t& categ) const {
  assert(categ<32);
  wxUint32 mask, res;
  // constructing the mask
  mask = size_t(1)<<categ;
  // doing a bitwise and to get the result
  res = mask & marks;
  if (res==0) return false;
  else return true;
}
//-----------------------------------------------
bool Set32::HasMark() const {
  return (marks!=0);
}
//-----------------------------------------------
wxUint32 Set32::GetNum() const {
  return marks;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// changing the marks
//-----------------------------------------------
void Set32::SetAll(wxUint32& inval) {
  marks = inval;
}
//-----------------------------------------------
void Set32::ClearMarks() {
  marks = 0;
}
//-----------------------------------------------
void Set32::SetMark(const size_t& categ, bool value) {
  assert(categ<32);
  wxUint32 mask;
  // constructing the mask
  mask = (wxUint32)(1)<<categ;
  if (!value) mask = ~mask;
  // applying
  if (value) marks |= mask;
  else marks &=mask;
}
//-----------------------------------------------
void Set32::FlipMark(const size_t& categ) {
  assert(categ<32);
  SetMark(categ,!IsMarked(categ));
}
//============================================================================
wxString UpdateStatus2String(const jf_FUpdateStatus& inval) {
  wxString result;
  if (inval==jud_NONE) result = wxEmptyString;
  else if (inval==jud_NEW) result = wxT("New!");
  else if (inval==jud_UPDATED) result = wxT("Updated!");
  else if (inval==jud_MISSING) result = wxT("Missing!");
  else if (inval==jud_AUTHORNC) result = wxT("Author Name Changed!");
  else assert(false);
  // done
  return result;
}
//*****************************************************************************




