//*****************************************************************************
// Name:        coretypes.h
// Author :     John Q Metro
// Purpose :    Declares some core data holding types
// Created:     June 9, 2010
// Updated:     January 19, 2011
//*****************************************************************************
#ifndef WX_PRECOMP
  #include <wx/wx.h>
#else
#include "wx/wxprec.h"
#endif

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#define JF_CORETYPES
//*****************************************************************************
// implements a set of 32 booleans using an int
class Set32 : public wxObject {
  public:
    Set32();
    // info methods
    bool IsMarked(const size_t& categ) const;
    bool HasMark() const;
    wxUint32 GetNum() const;
    // changing the marks
    void SetAll(wxUint32& inval);
    void ClearMarks();
    void SetMark(const size_t& categ, bool value);
    void FlipMark(const size_t& categ);
  protected:
    wxUint32 marks;
};
//=======================================================
// a fic update status enum
enum jf_FUpdateStatus {jud_NONE, jud_UPDATED, jud_MISSING, jud_NEW, jud_AUTHORNC};
// enum to string method
wxString UpdateStatus2String(const jf_FUpdateStatus& inval);
//*****************************************************************************
