/*****************************************************************************
 Name:        misc_types1.h
 Author :     John Q Metro
 Purpose :    Some types
 Created:     April 2, 1010
 Updated:     December 16, 2012
 ******************************************************************************/
#ifndef WX_PRECOMP
  #include <wx/wx.h>
#else
#include "wx/wxprec.h"
#endif

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#define JFMISCTYPES1
#include <map>
//*****************************************************************************
/* some fanfic (and other things as well), attach text tags to stories/items.
 Therefore, one can has a filter that filters on these. tags can be excluded,
 necessary, alternate... we need a types to hold that data */

enum jfTAG_STATUS { jfts_NONE, jfts_INCLUDE, jfts_ALTERNATE, jfts_EXCLUDE };

class jfTagListing : public std::map<wxString,jfTAG_STATUS> {
	public:
		// to and from a single string (semicolon delimited)
		wxString ToString() const;
		bool FromString(const wxString& instr);
		// initializing
		bool FromArray(const wxChar* insrc[], size_t incount);
		bool FromStrArray(const wxArrayString* insrc);
		// special, retuns false if empty or if all values are jfts_NONE
		bool Valset() const;
		// tag replacement
		bool ReplaceTag(wxString oldt, wxString newt);
		bool ReplaceTags(wxArrayString* replist);
		// special, returns true if the tags match the given list
		bool MatchTags(const wxChar* inlist[], size_t inlistcount);
		/* special, compares inputted tags to tags already in the list. Returns
		FALSE if there are tags in the list not in input. Tags in input that are
		not in the list are added. falsechoice controls what we do if we return
		false. options are 0:ignore, 1:remove, and 2:abort */
		bool Reconcile(const wxChar* inlist[], size_t inlistcount, size_t falsechoice);
	protected:
};
//*****************************************************************************
