/*****************************************************************************
Name:        vectors.cpp
Author :     John Q Metro
Purpose :    vector declarations
Created:     April 29, 2009
Updated:     October 19, 2013
******************************************************************************/
#ifndef VECTORS_H_INCLUDED
  #include "vectors.h"
#endif // VECTORS_H_INCLUDED
#ifndef UTILS1_H_INCLUDED
  #include "../utils/utils1.h"
#endif // UTILS1_H_INCLUDED
#ifndef BASEOBJ_H_INCLUDED
  #include "../objs/baseobj.h"
#endif // BASEOBJ_H_INCLUDED
//------------------------------------
#include <assert.h>
/******************************************************************************/
wxString jfIndexVector::ToDelimString(wxChar dval) const {
  // constants and variables
  const wxString num_str = wxT("0123456789");
  wxString result;
  size_t qindex;
  // checking the delimiter
  assert(wxNOT_FOUND==num_str.Find(dval));
  // going ahead
  for (qindex=0;qindex<size();qindex++) {
    result += SInt2Str(at(qindex));
    if (qindex!=(size()-1)) result += dval;
  }
  // done
  return result;
}
//---------------------------------------------------------------
bool jfIndexVector::SetFromString(wxString inval, wxChar dval) {
  // variables
  wxArrayString* was = NULL;
  unsigned long qval;
  size_t lindex, lsize;
  size_t lqval;
  // converting
  was = ListToStrArr(inval,dval);
  clear();
  if (was==NULL) return true;
  lsize = was->Count();
  if (lsize==0) {
    delete was;
    return true;
  }
  // now we loop and try to convert each string to a value
  for (lindex=0;lindex<lsize;lindex++) {
    if (!Str2ULong(was->Item(lindex),qval)) {
      delete was;
      return false;
    }
    else {
      lqval = qval;
      push_back(lqval);
    }
  }
  // done
  delete was;
  return true;

}
//==============================================================================
// the constructors
jfResultHtmlVector::jfResultHtmlVector():std::vector<wxHtmlListBox*>() {
  leftover=NULL;
}
//----------------------------------------------------------------------------
// test for null
bool jfResultHtmlVector::LNNull() const {
  return (leftover!=NULL);
}
//--------------------------------------------------------------------------
bool jfResultHtmlVector::NotEmpty() const {
  if (LNNull()) return true;
  else return !empty();
}
//===============================================================================
/* DiscardTest returns true if the input is in the set, otherwise it adds the
 input to the set and returns false */
//--------------------------------------------
bool jfIDStore::DiscardTest(size_t testval) {
  // special case
  if (empty()) {
    insert(testval);
    return false;
  }
  // general
  else {
    if (find(testval)==end()) {
      insert(testval);
      return false;
    }
    else return true;
  }
}
//--------------------------------------------
bool jfIDStore::DiscardTest(jfBaseObj* testobj) {
  assert(testobj!=NULL);
  size_t testval = testobj->GetID();
  // special case
  if (empty()) {
    insert(testval);
    return false;
  }
  // general
  else {
    if (find(testval)==end()) {
      insert(testval);
      return false;
    }
    else return true;
  }

}
/******************************************************************************/
