/*****************************************************************************
Name:        vectors.h
Author :     John Q Metro
Purpose :    vector declarations
Created:     April 29, 2009
Updated:     March 28, 2015
******************************************************************************/
#ifndef VECTORS_H_INCLUDED
#define VECTORS_H_INCLUDED
#endif // VECTORS_H_INCLUDED
//-------------------------------------------------------------------------------
#include <vector>
#include <wx/htmllbox.h>
#include <set>
/******************************************************************************/
class jfOIndexVector : public std::vector<wxInt32> {};
//------------------------------------------------------------------------------
class jfResultUnit;
// first off, a vector of result units
class jfResultUnitVector : public std::vector<jfResultUnit*> {};
//==========================================================================
// next, a vector for indexes
class jfIndexVector : public std::vector<unsigned int> {
  public:
    wxString ToDelimString(wxChar dval) const;
    bool SetFromString(wxString inval, wxChar dval);
};
//======================================================================
// next, a vector for HtmlListBox pointers
class jfResultHtmlVector : public std::vector<wxHtmlListBox*>{
  public:
    wxHtmlListBox* leftover;
    // public methods
    // the constructor
    jfResultHtmlVector();
    // test for null
    bool LNNull() const;
    bool NotEmpty() const;
};
//===========================================================================
class jfBasePD;
// a vector of jfBasePD items
class jfPDVector : public std::vector<jfBasePD*> {};
//===========================================================================
// two extra vectors for keeping track of top-level pages
class jfWindowsIDVector : public std::vector<wxWindowID> {};
class jfBoolVector : public std::vector<bool> {};
//===========================================================================
class jfBaseObj;
// class for storing fic ids, used for eliminating duplicates
class jfIDStore : public std::set<size_t> {
  public:
    /* DiscardTest returns true if the input is in the set, otherwise it
    adds the input to the set and returns false */
    bool DiscardTest(size_t testval);
    bool DiscardTest(jfBaseObj* testobj);
};

/******************************************************************************/
