/*****************************************************************************
Name    : altlog.h
Basic   : Alternate logging (using wxFile)
Author  : John Q Metro
Started : March 3, 2013
Updated : March 3, 2013
Notes   :

******************************************************************************/
#ifndef ALTLOG_H_INCLUDED
#define ALTLOG_H_INCLUDED
#endif // ALTLOG_H_INCLUDED
//--------------------------------------------------

#include <wx/file.h>
#include <wx/string.h>
#include <wx/thread.h>
//**********************************************************************************
/* logging class, created because I cannot get wxLogMessage to work on FreeBSD */
class jfAltLogger : public wxObject {
  public:
    // constructor
    jfAltLogger();
    jfAltLogger(wxString fnamein);  // constuctor which also creates logfile
    // file manipulations
    bool MakeLog(wxString fnamein); // create and open logfile
    bool CloseLog();                // close current logfile (if any)
    bool IsOpen() const;           // check if there is an active logfile
    wxString GetLogname() const;    // returns the log filename
    // logging
    bool LogString(wxString in_msg);
    // destructor
    ~jfAltLogger();
  protected:
    wxString logname;
    wxFile* outfile;
};
//=================================================================================
namespace altlog {
  const wxString logname = wxT("trace_bsd.txt");
  extern jfAltLogger* logvar;
  extern wxMutex loglock;
  extern bool doaltlog;
}
//**********************************************************************************
