/////////////////////////////////////////////////////////////////////////////
// Name:        charconv.h
// Author :     John Q Metro
// Purpose :    Declarations for character conversion stuff
// Created:     24.10.05
// Updated:     November 24, 2013
/////////////////////////////////////////////////////////////////////////////
// ----------------------------------------------------------------------------
// headers
// ----------------------------------------------------------------------------
// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

// for all others, include the necessary headers
#ifndef WX_PRECOMP

#endif

#include "wx/protocol/http.h"

#define CHARCONV_H_INCLUDED

//***************************************************************************
// a function that scans the returned data for the charset info
wxString ExtractCharset(const wxByte* rawdata, size_t size);
// converts raw data to a wxstring
wxString* RawToString(wxByte* indata, size_t length,wxString encoding);
// Concatenates the second bytestring onto the end of the first
wxInt32 ConcatRaw(wxByte*& first, wxByte* second, size_t maxsize,const size_t& flen, const size_t& slen);
// when given two byte strings, picks the biggest, and deletes the other one
bool PickBiggest(wxByte*& biggest, size_t& biglen, wxByte*& contender, size_t& clength);
// a function that scans the data passed to it for redirection info
wxString GetRedirect(wxByte* rawdata, size_t size);
//----------------------------------------------------
// new, wxString 2 char*
char* wxStringToCharString(const wxString& inval, bool unicode);
/////////////////////////////////////////////////////////////////////////////
