/*****************************************************************************
Name    : htmlparse.h
Basic   : Defines some utility functions and things used in manipulating html
Author  : John Q Metro
Started : September 13, 2009
Updated : April 2, 2010

******************************************************************************/
#ifndef HTMLPARSE_H_INCLUDED
#define HTMLPARSE_H_INCLUDED
#endif // HTMLPARSE_H_INCLUDED
//------------------
#ifndef UTILS2_H_INCLUDED
  #include "utils2.h"
#endif // UTILS2_H_INCLUDED
//----------------
#include <wx/textfile.h>
/*****************************************************************************/
namespace htmlparse {
  const wxString entity_fname = wxT("html_entities.dat");
  extern wxArrayString* entity_names;
  extern wxString entity_chars;
  extern bool loaded;
  // data loading
  bool LoadEntities();
  // parsing
  bool EntityToChar(wxString inval, wxChar& outval);
  wxString StripTags(const wxString& inval);
  wxString ConvertEntities(const wxString& inval, bool keephtml);
  wxString HTML2Text(const wxString& inval);
	wxString ToUTFHtml(const wxString& inval);
	bool TestEntity(const wxString& inval);
  // escaping
  wxString UrlEscape(const wxString& indata, bool esc_tilde);
  wxString GoogleEscape(const wxString& instring);

}
/*****************************************************************************/
