/*****************************************************************************
Name    : logging.h
Basic   : Separates out logging from the other stuff
Author  : John Q Metro
Started : January 13, 2011
Updated : March 3, 2012
Latest Changes : Decided to eliminate the multiple logfile stuff which I have
  never used. Also the creation of altlog because of problems on FreeBSD.

******************************************************************************/
#ifndef LOGGING_H_INCLUDED
#define LOGGING_H_INCLUDED
#endif // LOGGING_H_INCLUDED
//-----------------------------------------------
#ifndef WX_PRECOMP
  #include <wx/wx.h>
#else
#include "wx/wxprec.h"
#endif

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#include <vector>

//*****************************************************************************
// some constants and exposed variables
extern wxLogStderr* logtarget0;
extern wxString LOGNAME0;
//=======================================================================
// log creation/manipulation
// creates a logfile using the proper values
wxLogStderr* MakeOutLog(bool append = false);
// initializes the main log (logtarget0)
void InitMainLog();

//======================================================================
// logging methods that include a function name and index
void jfXLogMessage(const wxChar* funcname,size_t index, wxString info);
void jfXLogMessageS(const wxChar* funcname,size_t index, size_t data);
void jfXLogMessageI(const wxChar* funcname,size_t index, wxInt32 data);
void jfXLogMessageU(const wxChar* funcname,size_t index, size_t data);
void jfXLogMessageB(const wxChar* funcname,size_t index, bool data);
void jfXLogMessage(const wxChar* funcname,size_t index);
void jfXLogMessage2S(const wxChar* funcname,size_t index, size_t data1, size_t data2);
void jfXLogMessage2U(const wxChar* funcname,size_t index, size_t data1, size_t data2);
void jfXLogMessageBytes(const wxChar* funcname,size_t index, const wxByte* indata, size_t iindex, size_t length);
//-------------------------------------------------------------
// a core methods that handles building the first part of the above result
wxString BLogCore(const wxChar* funcname, size_t index, bool more);
//----------------------------------------------------------------------------------------
/* a logging function that hides the multiple platform specific
logging methods */
void jfXLogString(wxString in_msg);
//============================================================
// assert with logging
void jfXAssertLog(bool condition, wxString funcname, const wxChar* outmsg);
//*****************************************************************************
