/*****************************************************************************
Name    : utils3.h
Basic   : Defines some more utility functions and things used in the other files
Author  : John Q Metro
Started : January 7, 2011
Updated : July 6, 2015
Notes   :

******************************************************************************/
#define UTILS3_H_INCLUDED

#ifndef WX_PRECOMP
  #include <wx/wx.h>
#else
#include "wx/wxprec.h"
#endif

#include <wx/textfile.h>
//****************************************************************************
// writes data to a file, not append, overwrite
bool ToFile(wxString indata, wxString filename);
// reads data from a file
bool FromFile(wxString& outdata, wxString filename);
// trims text files down to a certain number of lines. mainly used to trim the logfile
bool TrimTextFile(wxString filename, size_t lcount);
// produces a version of the string with some characters replaced by _
extern const wxString UFNAME_DELIMS;
wxString UBReplace(wxString filename, wxString delimchars);
// file i/o creator
wxTextFile* GetOpenFile(wxString filename, bool write);
// more file i/o
bool AppendAS2File(wxArrayString* indata, wxTextFile* target);
bool AppendFile2AS(wxArrayString* target, wxTextFile* source);
// wxArrayString To File and vice versa
bool ToFileAS(wxArrayString* indata, wxString filename);
wxArrayString* FromFileAS(wxString filename);
// Query encoding a string for URL query usage
wxString QueryEncode(const wxString invalue, bool encodetilde=false);
// deletes a directory and it's contents
bool DeleteDirectoryTree(wxString dir_to_delete);
/* Annoyingly, wxWidgets provides no simple method to get a complete list of all
files and subdirectories in a directory. (wxDir::GetAllFiles never returns directories).
This function does that, the paths are complete and directories are terminated with the
path separator. */
bool GetDirectoryTreeList(const wxString indir, wxArrayString& outdata);

//*****************************************************************************
