/////////////////////////////////////////////////////////////////////////////
// Name:        newfic_coll.h
// Author :     John Q Metro
// Purpose :    fic updating required some extra methods and info in the data collection
// Created:     January 29, 2011
// Updated:     May 26, 2011
/////////////////////////////////////////////////////////////////////////////
#ifndef NEWFIC_COLL_H_INCLUDED
#define NEWFIC_COLL_H_INCLUDED
#endif // NEWFIC_COLL_H_INCLUDED
//-------------------------------------
#ifndef FFN_ITEMCOLL
  #include "../../fanficnet/data/ffn_itemcoll.h"
#endif
#ifndef UPD_TYPES_H_INCLUDED
  #include "upd_types.h"
#endif // UPD_TYPES_H_INCLUDED
#ifndef RESULTCOLLECT_H_INCLUDED
  #include "../../core/structs/resultcollect.h"
#endif // RESULTCOLLECT_H_INCLUDED
#ifndef JF_FFNSEARCH
  #include "../../fanficnet/data/ffn_search.h"
#endif
#ifndef FFN_MULTICOLL
  #include "../../fanficnet/data/ffn_mulcoll.h"
#endif
/*****************************************************************************/
class jfFFN_NewItemCollection : public jfFFNItemCollectionCore {
  friend class jfFFNItemCollection;
  public:
    // a constructor
    jfFFN_NewItemCollection(jfFFNSearch* sdata_in);
    jfFFN_NewItemCollection(jfFFNSearch* sdata_in, const jfFFNSCategory* cat_linkin, const jfFicLimit *indatelim);
    // date limits
    void SetDatelimit(const jfFicLimit* flim = NULL);
    bool DatelimitReached() const;
    // the destructor
    ~jfFFN_NewItemCollection();
  protected:
    // implemented virtual methods
    bool ExitCheck(const jfFFNItem* intest);
    // internal data
    const jfFicLimit *datelim;
    bool datelim_reached;
    bool extracted;
};
//===========================================================================
// holding multiple results
class jfFFN_NewResCollection : public jfFFNResColl {
  public:
    // core constructor
    jfFFN_NewResCollection(jfFFNSearch* zsearch);
    // item creation
    bool MakeItemCollection(const wxString& src_in, const jfFFNSCategory* cat_linkin, const jfFicLimit* flim, wxString& outerr);
    // limit testing
    size_t GetLimit(size_t zindex) const;
    bool LimitReached(size_t in_index) const;
        // some more methods
    jfFFN_NewItemCollection* GetCurrPointerT();
    bool CompareCats(const jfFFNSCategory* tocheck) const;
  protected:
};
/*****************************************************************************/
