/////////////////////////////////////////////////////////////////////////////
// Name:        upd_types.h
// Author :     John Q Metro
// Purpose :    Misc types and untils helpful in fanfiction.net updating
// Created:     January 18, 2011
// Updated:     August 21, 2012
/////////////////////////////////////////////////////////////////////////////
#ifndef WX_PRECOMP
  #include <wx/wx.h>
#else
#include "wx/wxprec.h"
#endif

#ifdef __BORLANDC__
    #pragma hdrstop
#endif
//--------------------------------------------
#ifndef UPD_TYPES_H_INCLUDED
#define UPD_TYPES_H_INCLUDED
#endif // UPD_TYPES_H_INCLUDED
//---------------------------------------------
#ifndef JFFNFICOBJ
  #include "../../fanficnet/data/ffn_ficobj.h"
#endif // BASEOBJ_H_INCLUDED

//****************************************************************************
// simple wrapping of author info
class jfAuthorInfo : public wxObject {
  public:
    // constructor
    jfAuthorInfo(size_t in_authorid, wxString in_authname);
    jfAuthorInfo(const jfAuthorInfo& inval);
    // getting info
    size_t GetAuthorID() const;
    wxString GetAuthorName() const;
    wxString GetUrl() const;
  protected:
    wxString author_name;
    size_t author_id;
};
//=========================================================================
// the fic object class when extracted from an author's page
class jfFFNItemAuthor : public jfFFNItemCore {
  public:
    // constructors
    jfFFNItemAuthor();
    jfFFNItemAuthor(const wxString& indata, const jfAuthorInfo& inauth);
    // setting data
    bool SetFromString(const wxString& indata, const jfAuthorInfo& inauth);
    void ChangeAuthorName(const wxString& inval);
    // getting data
    wxString GetCatname() const;
    // implemented virtual methods
    virtual wxString GetTypeID() const;
    virtual bool LoadValues(jfSkeletonParser* inparser) const;
  protected:
    virtual bool GetLinkTitle();
    // io methods
    virtual bool AddExtraStuff(wxTextFile* outfile) const ;
    virtual bool ReadExtraStuff(jfFileReader* infile);
    // since we do not use category links, we do check the category name
    wxString catname;
};
//=====================================================================
// bundles fic id and published date for a limit: do not get fics with lower id or earlier date
class jfFicLimit : public wxObject {
  public:
    // constructors and data methods
    jfFicLimit(wxDateTime dlimit, size_t idlimit);
    void ChangeLimit(size_t inval, bool innodate);
    size_t IdLimit() const;
    // testing...
    bool IsLater(const jfFFNItemCore* test) const;
  protected:
    wxDateTime fpublished;
    size_t id_limit;
    bool nodate;
};
//****************************************************************************
