/******************************************************************************
* Name:        upd_disp.h
* Author :     John Q Metro
* Purpose :    Large panel holding the main status and the result viewlists
* Created:     March 26, 2011
* Updated:     January 18, 2014
******************************************************************************/
#ifndef UPD_DISP_H_INCLUDED
#define UPD_DISP_H_INCLUDED
#endif // UPD_DISP_H_INCLUDED
//------------------------------------
#ifndef UPD_MAINPANEL_H_INCLUDED
  #include "upd_mainpanel.h"
#endif // UPD_MAINPANEL_H_INCLUDED
#ifndef UPD_PANEL2_H_INCLUDED
  #include "upd_panel2.h"
#endif // UPD_PANEL2_H_INCLUDED
#ifndef RESULT_PANEL_H_INCLUDED
  #include "../../interface/display/result_panel.h"
#endif // RESULT_PANEL_H_INCLUDED
#ifndef DISPLAY_BASE2_H_INCLUDED
  #include "../../interface/display/display_base2.h"
#endif // DISPLAY_BASE2_H_INCLUDED
//****************************************************************************
class jfUpdateDisplay : public wxPanel {
  public:
    // the constructor
    jfUpdateDisplay(wxWindow* parent, jfFFN_UpdateBundle* inval, wxWindowID id = wxID_ANY, const wxString& name = wxT("jfUpdateDisplay"));
    // starting phase 1
    bool LoadOld();
    // extra methods
    void SetPopupMenu(jfPopupMenu* inmenu);
    bool ChangeBHeight(size_t nheight);
    bool ChangeMode(bool tosmall);
    size_t GetSelectedIndex() const;
    bool StopSearch();
  protected:
    // the main GUI elements
    jfHtmlResultCollection_FFN* main_results;  // for showing the results
    jfUpDMainpanel* status_display;
    // sizer
    wxBoxSizer* main_sizer;
    // internal data
    jfFFN_UpdateBundle* maindata;
};
//===========================================================================
// top level update interface panel
class jfUpdateTopLevel : public DisplayPanelCore {
  public:
    // constructor
    jfUpdateTopLevel(wxWindow* parent, jfFFN_UpdateBundle* inval, wxWindowID id = wxID_ANY, const wxString& name = wxT("jfUpdateDisplay"));
    // handles the event that everything is done
    void HandleAllDone(wxCommandEvent& event);
    // right click menu event handlers
    void OnRMenuDownloadFic(wxCommandEvent& event);
    // shared virtual methods
    virtual bool WriteAll2Html();
    virtual bool WriteCurrent2Html();
    virtual void WindowResized(size_t x, size_t y);
    // starting phase 1
    bool LoadOld();
    // io
    wxString GetSearchName() const;
    bool OrderStop();
    bool WriteFFNBundle(wxString inpath) const;
  protected:
    // GUI Stuff
    wxNotebook* mainbook;
    jfUpdateDisplay* panel1;
    jfFFNUpd_Panel2* panel2;
    jfFilterMapEditor* panel3;
    jfMainCategoriesEditor* panel4;
    // sizer
    wxBoxSizer* msizer;
    // internal data
    jfFFN_UpdateBundle* indata;
    // menu data
    jfPopupMenu* rc_menu;

    DECLARE_EVENT_TABLE()

};
//****************************************************************************
