//****************************************************************************
// Name    :  auth_thread.h
// Author  :  John Q Metro
// Purpose :  Thread class that handles updating old fics by checking the author pages.
// Created :  January 22, 2011
// Updated :  January 18, 2014
//****************************************************************************
#ifndef AUTH_THREAD_H_INCLUDED
#define AUTH_THREAD_H_INCLUDED
#endif // AUTH_THREAD_H_INCLUDED
//--------------------------------------
#ifndef RES_BUNDLE_H_INCLUDED
  #include "../data/res_bundle.h"
#endif // RES_BUNDLE_H_INCLUDED
#ifndef AUTH_COLL_H_INCLUDED
  #include "../data/auth_coll.h"
#endif // AUTH_COLL_H_INCLUDED
#ifndef MULTI_THREADS_H_INCLUDED
  #include "../../connect/multi_threads.h"
#endif // MULTI_THREADS_H_INCLUDED
/*****************************************************************************/
bool FFN_AuthorMissing(const wxString* in_pagedata);
//=============================================
class jfAuthThread : public jfMultiThreadMixin<jfThreadWithDownload> {
  public:
    // constructor
    jfAuthThread();
    // data to set before we start
    bool SetBundle(jfFFN_UpdateBundle* inval);
    // doing things
    virtual wxThread::ExitCode Entry();
    // messaging
    virtual void SendDone(jfDown::ResultAction done_status);
  protected:
    // internal methods
    bool HandleCatgeory();
    bool HandleStory();
    bool CheckAndDownload(jfFFNItem* initem, bool& missing);
    // sending info
    void SendUpdateCat(const jfFFNSCategory* nczat);
    void SendUpdateFic(jfResultUnit* neval, size_t tval);
    // main data (external)
    jfFFN_UpdateBundle* sandres;
    // working info
    const jfAuthorInfo* curr_auth;
    jfFFNItemCollection* curr_collect;
    // extra info
    size_t ficcount,ficindex;

};
/*****************************************************************************/
