/******************************************************************************
* Name:        loadold_th.h
* Author :     John Q Metro
* Purpose :    Thread to load the old results to the listbox before we start updating
* Created:     February 3, 2011
* Updated:     November 30, 2013
******************************************************************************/
#ifndef LOADOLD_TH_H_INCLUDED
#define LOADOLD_TH_H_INCLUDED
#endif // LOADOLD_TH_H_INCLUDED
#ifndef RES_BUNDLE_H_INCLUDED
  #include "../data/res_bundle.h"
#endif // RES_BUNDLE_H_INCLUDED
//------------------------------------
#include <wx/thread.h>
/***************************************************************************/
class jfPhase13_Thread : public wxThread {
  public:
    // constructor
    jfPhase13_Thread();
    // data setting
    bool DataIsSet() const;
    bool SetData(jfFFN_UpdateBundle* odata_in, wxWindow* in_msgtarget);
  protected:
    // extra methods
    void LimSleep(size_t inlimit, size_t fcount);
    // status sender events
    void SendStart(size_t catcount);
    void StartCat();
    void EndCat();
    virtual void SendEnd() = 0;
    //  links
    bool dataset;
    jfFFN_UpdateBundle* old_data;
    wxWindow* msg_target;
    // current data
    size_t catindex;
    wxString catname;
    size_t plimcount;

};
//**************************************************************************
class jfLOR_Thread : public jfPhase13_Thread {
  public:
    // constructor
    jfLOR_Thread();
    // the main thread
    virtual wxThread::ExitCode Entry();
  protected:
    virtual void SendEnd();
    void SendBulkECat();
    // internal upload tracking info
    jfBulk_EmptyCatInfo* ecatdata;
    size_t emptcount;
    wxString ocatname;
};
/***************************************************************************/
