//****************************************************************************
// Name    :  newf_thread.h
// Author  :  John Q Metro
// Purpose :  Thread class that handles getting new fics, has a threshold limit
// Created :  January 26, 2011
// Updated :  January 6, 2014
//****************************************************************************
#ifndef NEWF_THREAD_H_INCLUDED
#define NEWF_THREAD_H_INCLUDED
#endif // NEWF_THREAD_H_INCLUDED
//--------------------------------------------
#ifndef RES_BUNDLE_H_INCLUDED
  #include "../data/res_bundle.h"
#endif // RES_BUNDLE_H_INCLUDED
#ifndef MULTI_THREADS_H_INCLUDED
  #include "../../connect/multi_threads.h"
#endif // MULTI_THREADS_H_INCLUDED
/****************************************************************************/
class jfFFNUpdateNewThread : public jfMultiDownloadThread {
  public:
    // constructor
    jfFFNUpdateNewThread();
    // data setting
    bool SetBundle(jfFFN_UpdateBundle* inval);
    // a reminder
    virtual wxThread::ExitCode Entry();
  protected:
    // implemented virtual plug-in methods to handle some vital bits
    virtual void PreFetch1();
    virtual void PreFetch2();
    virtual void SetUrl();
    virtual bool ProcessPage();
    virtual size_t NewPagecount() const;
    virtual void PostPageAction();
    // custom internal method
    bool GetCategory();
    // internal variables
    jfFicLimit* thelimiter;
    // main data (external)
    jfFFN_UpdateBundle* sandres;
    bool coldcat;
    bool fpageskip;
    // in addition to cat indexes for new cats, we have a separate set for the old
    size_t or_count, or_index;
};
/****************************************************************************/
