//*******************************************************************************
// Name:        post_combine.cpp
// Author :     John Q Metro
// Purpose :    After doing updates, we have a collections for new results and one
//               for old and updated fics. This threads combined them
// Created:     Febuary 22, 2010
// Updated:     June 14, 2011
//*******************************************************************************
#ifndef POST_COMBINE_H_INCLUDED
  #include "post_combine.h"
#endif // POST_COMBINE_H_INCLUDED
//----------------------------------------
#ifndef LOADOLD_TH_H_INCLUDED
  #include "loadold_th.h"
#endif // LOADOLD_TH_H_INCLUDED
#ifndef INTERFACE_IDS_H_INCLUDED
  #include "../../interface/interface_ids.h"
#endif // INTERFACE_IDS_H_INCLUDED
//----------------------------------------
//*******************************************************************************
// constructor
jfUCombine_Thread::jfUCombine_Thread():jfPhase13_Thread() {}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// the main thread
wxThread::ExitCode jfUCombine_Thread::Entry() {
  // constants
  const wxString fname = wxT("jfUCombine_Thread::Entry");
  // checks
  /**/jfXLogMessage(fname,1);
  assert(dataset);
  assert((old_data->new_data)!=NULL);
  // variables
  size_t cmaxc;
  bool hcres;
  // we start
  /**/jfXLogMessage(fname,2);
  cmaxc = old_data->new_data->NumSCats();
  SendStart(cmaxc);
  /**/jfXLogMessageS(fname,3,cmaxc);
  old_data->result_data->GoToFirst();
  old_data->new_data->GoToFirst();
  /**/jfXLogMessage(fname,4);
  // the main loop
  for(catindex=1;catindex<=cmaxc;catindex++) {
    StartCat();
    /**/jfXLogMessageS(fname,5,catindex);
    catname = old_data->new_data->GetCurrPointerT()->GetName();
    /**/jfXLogMessage(fname,6,catname);
    hcres = HandleCategory();
    /**/jfXLogMessageB(fname,7,hcres);
    assert(hcres);
    old_data->new_data->NextCategory();
    EndCat();
    /**/jfXLogMessageI(fname,8,catindex);
  }
  Sleep(1000);
  /**/jfXLogMessage(fname,9);
  // done
  SendEnd();
  return 0;
}
//-------------------------------------------------------------------------
// private helper method
bool jfUCombine_Thread::HandleCategory() {
  // constants
  const wxString fname = wxT("jfUCombine_Thread::HandleCategory");
  // variables
  bool samecat;
  bool rval;
  jfFFN_NewItemCollection* nic_curr;
  const jfFFNSCategory* tcat;
  // we do the testing
  /**/jfXLogMessage(fname,1);
  /**/jfXLogMessageS(fname,2,old_data->result_data->SCatIndex());
  tcat = old_data->GetOldCategory();
  if (tcat==NULL) samecat = false;
  else {
    /**/jfXLogMessage(fname,3,tcat->GetName());
    samecat = old_data->new_data->CompareCats(tcat);
  }
  /**/jfXLogMessageB(fname,4,samecat);
  nic_curr = old_data->new_data->GetCurrPointerT();
  /**/jfXLogMessage(fname,5,nic_curr->GetCatName());
  // same value
  if (samecat) {
    /**/jfXLogMessage(fname,6);
    rval = old_data->result_data->InsertFromNewCollection(nic_curr);
  }
  else {
    /**/jfXLogMessage(fname,7);
    rval = old_data->result_data->InsertNewCollection(nic_curr);
  }
  /**/jfXLogMessageB(fname,8,rval);
  return rval;
}
//---------------------------------------
void jfUCombine_Thread::SendEnd() {
  // creating
  wxCommandEvent eventx(jf_UPDATE_AUXTHREAD_DONE, msg_target->GetId());
  // sending the message
  wxPostEvent(msg_target,eventx);
}
//*******************************************************************************
