/////////////////////////////////////////////////////////////////////////////
// Name:        ffn_parts.h
// Author :     John Q Metro
// Purpose :    Downloading fics, we need structures to hold the data
// Created:     July 12, 2011
// Updated:     July 8, 2016
/////////////////////////////////////////////////////////////////////////////
#ifndef FFNDOWN_PARTS_H_INCLUDED
#define FFNDOWN_PARTS_H_INCLUDED
#endif // FFNDOWN_PARTS_H_INCLUDED
//-----------------------------------------
#include <wx/object.h>

#ifndef HTMLSKELTON_H_INCLUDED
  #include "../../core/utils/htmlskelton.h"
#endif // HTMLSKELTON_H_INCLUDED
#ifndef UTILS2_H_INCLUDED
  #include "../../core/utils/utils2.h"
#endif // UTILS2_H_INCLUDED
#ifndef FICOBJG_H_INCLUDED
  #include "../../fanfic/data/ficobj.h"
#endif // FICOBJG_H_INCLUDED
#ifndef SKELSTORE_H_INCLUDED
  #include "../../core/objs/skelstore.h"
#endif // SKELSTORE_H_INCLUDED
//**************************************************************************
// paramters for the dialog to download thread
class jfFicDownParams : public wxObject {
  public:
    // stuff common to all threads
    wxString base;
    size_t sizeguide;
    jfSkeletonFicPart* theskel;
    // needed for specific downloads only
    wxString indir;
    jf_FICTYPE downtype;
    bool check_complete;
    wxString firsturl;
    jfFicExtract* extract_data;
    // constrcutors
    jfFicDownParams(wxString in_base, size_t in_sizeguide, jfSkeletonFicPart* in_theskel);
  protected:
};


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// hold a fanfic part
class jfFicPart : public wxObject {
  public:
    // constructors
    jfFicPart();
    // info methods
    bool IsValid() const;
    size_t GetPartcount() const;
    wxString GetErr() const;
    wxString GetContents() const;
    void LoadCoreValues(jfSkeletonParser* inparser) const;
    // change methods
    bool SetFromString(wxString inpage);
  protected:
    // parse error registering
    bool SetParseError(wxString inval);
    virtual bool SetFromStringCore() = 0;
    // data
    wxString partname;
    wxString partcontents;
    size_t partcount;
    size_t partindex;
    // err handling and parsing
    bool validdata;
    wxString errmsg;
    jfStringParser* sparser;
};
//-----------------------------------------------------------------------
class jfFicPart_FFN : public jfFicPart {
  public:
    // constructors
    jfFicPart_FFN();
    jfFicPart_FFN(wxString inpage);
    // implemented virtual methods
    jfFicExtract_FFN* FirstFromString(wxString inpage);
  protected:
    virtual bool SetFromStringCore();
    bool FirstProcessStart(wxString inval, wxString& out_title);
    bool DateAndCompletion(jfFicExtract_FFN* in_result);
    bool PartsProcessing();
    // variables
    size_t sid;
    bool first;
};
//***************************************************************************
