//****************************************************************************
// Name:        ficdown_parts2.h
// Author :     John Q Metro
// Purpose :    Downloading fics, methods to extract info from pages, as well
//                as holders for fanfic parts
// Created:     March 23, 2012
// Updated:     April 6, 2012
//****************************************************************************
#ifndef FICDOWN_PARTS2_H_INCLUDED
#define FICDOWN_PARTS2_H_INCLUDED
#endif // FICDOWN_PARTS2_H_INCLUDED
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#ifndef FFNDOWN_PARTS_H_INCLUDED
  #include "ffndown_parts.h"
#endif // FFNDOWN_PARTS_H_INCLUDED
//****************************************************************************
/* for fimfiction.net, we cannot get the necessary info from the chapter
pages, we need to use the index page. */
jfFicExtract_FIM* ExtractFromIndex_FIM(const wxString& inval);
// same for harry potter
jfFicExtract_HPF* ExtractFromIndex_HPF(const wxString& inval);
// mediaminer.org, multipart stories only
jfFicExtract_MMO* ExtractFromIndex_MMO(const wxString& inval);
//============================================================================
class jfFicPart_FIM : public jfFicPart {
  public:
    // constructors
    jfFicPart_FIM();
    jfFicPart_FIM(wxString inpage);
    // implemented virtual methods
  protected:
    virtual bool SetFromStringCore();
    bool HandleChapters(wxString inbuffer);
    void PartProcessing(wxString inbuffer);
};
//============================================================================
class jfFicPart_HPF : public jfFicPart {
  public:
    // constructors
    jfFicPart_HPF();
    jfFicPart_HPF(wxString inpage);
    // implemented virtual methods
  protected:
    virtual bool SetFromStringCore();
    bool HandleChapters(wxString inbuffer);
    void PartProcessing(wxString inbuffer);
};

//****************************************************************************
