//****************************************************************************
// Name:        ficdown_parts3.h
// Author :     John Q Metro
// Purpose :    Downloading fics, methods to extract info from pages, as well
//                as holders for fanfic parts
// Created:     April 6, 2012
// Updated:     July 7, 2016 (MediaMiner.Org changes)
//****************************************************************************
#ifndef FICDOWN_PARTS3_H_INCLUDED
#define FICDOWN_PARTS3_H_INCLUDED
#endif // FICDOWN_PARTS3_H_INCLUDED
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#ifndef FFNDOWN_PARTS_H_INCLUDED
  #include "ffndown_parts.h"
#endif // FFNDOWN_PARTS_H_INCLUDED

//****************************************************************************
//============================================================================
class jfFicPart_MMO : public jfFicPart {
  public:
    // constructors
    jfFicPart_MMO();
    jfFicPart_MMO(wxString inpage);
    // another way
  protected:
    virtual bool SetFromStringCore();
    bool HandleChapters();
    wxString PartProcessing(wxString inbuffer);

    size_t chapter_id;
};
//=============================================================================
class jfFicPart_AO3 : public jfFicPart {
  public:
    // constructors
    jfFicPart_AO3();
    jfFicPart_AO3(wxString inpage);
    // another way
    jfFicExtract_AO3* FirstFromString(wxString inpage);
  protected:
    // private methods
    virtual bool SetFromStringCore();
    bool HandleChapters(wxString inbuffer);
    void PartProcessing(wxString inbuffer);
    wxString CheckNotes(wxString inval) const;
    jfFicExtract_AO3* FParseError(wxString insmg, wxString extra = wxEmptyString);
    // internal data
    jfFicExtract_AO3* ffresult;
    wxString startnotes, endnotes;
};
//****************************************************************************
