/****************************************************************************
Name:        ficurl_parsing.h
Author  :    John Q Metro
Purpose :    When given a fic url to download, it has to be checked
Created :    July 8, 2016
Updated :    July 8, 2016

****************************************************************************/
#ifndef FICURL_PARSING_H_INCLUDED
  #define FICURL_PARSING_H_INCLUDED
#endif // FICURL_PARSING_H_INCLUDED
//----------------------------------
#ifndef FICOBJG_H_INCLUDED
  #include "../../fanfic/data/ficobj.h"
#endif // FICOBJG_H_INCLUDED
/***************************************************************************/
class jfFicURLParser {
  public:
    jfFicURLParser();
    // data in
    bool ParseURL(const wxString& input_url);
    // data out
    bool isValid() const;
    jf_FICTYPE getType() const;
    wxString firstURL();
    wxString FilenameBase();
  protected:
    bool ProcessStart(wxArrayString* urlarr, bool& writehttp);
    bool HandleFFN(wxArrayString* urlarr);
    bool HandleFIM(wxArrayString* urlarr);
    bool HandleAO3(wxArrayString* urlarr);
    bool HandleHPF(wxArrayString* urlarr);
    bool HandleMMO(wxArrayString* urlarr);

    // internal data
    bool validURL;
    bool writehttp;
    wxString inputURL;
    wxString outputURL;
    wxString fname_base;
    jf_FICTYPE type;
};
/***************************************************************************/
