/******************************************************************************
// Name:        ffndown_dialog.h
// Author :     John Q Metro
// Purpose :    Declares the dialog for downloading Fanfiction.Net fics
// Created:     July 16, 2011
// Updated:     July 8, 2016
******************************************************************************/
#ifndef FFNDOWN_DIALOG_H_INCLUDED
#define FFNDOWN_DIALOG_H_INCLUDED
#endif // FFNDOWN_DIALOG_H_INCLUDED
//-------------------------------------
#ifndef PPANEL_PARTS_H_INCLUDED
  #include "../../interface/threads/ppanel_parts.h"
#endif // PPANEL_PARTS_H_INCLUDED
#ifndef FFNDOWN_THREAD_H_INCLUDED
  #include "../threads/ffndown_thread.h"
#endif // FFNDOWN_THREAD_H_INCLUDED
#ifndef WIDGETS3_H_INCLUDED
  #include "../../interface/misc/widgets3.h"
#endif // WIDGETS3_H_INCLUDED
#ifndef PROGRESSPANEL_H_INCLUDED
  #include "../../interface/threads/progresspanel.h"
#endif // PROGRESSPANEL_H_INCLUDED
#ifndef FICURL_PARSING_H_INCLUDED
  #include "../data/ficurl_parsing.h"
#endif // FICURL_PARSING_H_INCLUDED
/*****************************************************************************/
// Progress panel for fanfic downloading
class jfFicDownProgPanel : public jfProgressPanelSingle {
  public:
    // constructor
    jfFicDownProgPanel();
  protected:
};
//***************************************************************************************
class jfDown_DialogCore : public wxDialog {
  public:
    // constructor
    jfDown_DialogCore(wxWindow* parent, wxWindowID id, const wxString& title, wxString inname);
    // event handlers from the panel
    virtual void EvEndSignal(wxCommandEvent& mevent) = 0;
    void EvFailSignal(wxCommandEvent& mevent);
    // button handler events
    virtual void EvStartButton(wxCommandEvent& mevent) = 0;
    void EventLaunchDirPicker(wxCommandEvent& mevent);
  protected:
    //private helpher methods
    void BuildLabels();
    void BuildWidgets();
    void LoadFromExtract(bool loadname);
    void FinishSizers(bool sdpnlabel);
    bool LoadSubdirs();
    wxString GetFullDir() const;
    // methods to change things during and after downloads
    void ClearParams();
    void EndCore(bool fail);
    // GUI elements
    // top row of labels
    wxStaticText* title_label;
    wxStaticText* author_tag;
    wxStaticText* author_label;
    wxBoxSizer* toprow;
    // second row of labels
    wxStaticText* parcount_label;
    wxStaticText* ficid_label;
    wxBoxSizer* rowtwo;
    // filename and split value entry
    wxButton* LDirPicker;
    jfLabeledEdit* name_edit;
    jfFilesizeHintWidget* split_guide;
    wxBoxSizer* rowthree;
    // pick a subdirectory
    wxStaticText* TSubLabel;
    wxChoice* SDirPicker;
    wxBoxSizer* sdp_sizer;
    wxBoxSizer* tworowstack;
    wxBoxSizer* topblock;
    wxBoxSizer* bottom_row;

    jfProgressPanelSingle* mpanel;
    // finally..
    wxStaticBoxSizer *data_sizer;
    wxBoxSizer* main_sizer;
    // internal data
    jfFicExtract* xmain_data;
    wxString dirstring;
    bool wax;
    jf_FICTYPE ftype;
    jfDownloadParams* tparams;
    jfFicDownParams* fparams;
    // event handler table
    DECLARE_EVENT_TABLE()
};
//*****************************************************************************
class jfDown_Dialog : public jfDown_DialogCore {
  public:
    // constructor
    jfDown_Dialog(wxWindow* parent, wxWindowID id, const wxString& title, jfFicExtract* in_main_data);
    // events
    virtual void EvEndSignal(wxCommandEvent& mevent);
    virtual void EvStartButton(wxCommandEvent& mevent);
  protected:
    jfDownThread* main_thread;
};
//*************************************************************************
class jfDown_Dialog2 : public jfDown_DialogCore {
  public:
    // constructor
    jfDown_Dialog2(wxWindow* parent, wxWindowID id, const wxString& title);
    // events
    virtual void EvEndSignal(wxCommandEvent& mevent);
    virtual void EvStartButton(wxCommandEvent& mevent);
    void EvHandleLoadInfo(wxCommandEvent& mevent);
    void EvCopyName(wxCommandEvent& mevent);
  protected:
    // internal helper methods
    bool TestUrlEntry();
    // gui elements
    jfLabeledEdit* urlentry;
    wxButton* cbtn;
    wxBoxSizer* tsizer;
    // internal data
    jfDownThread2* main_thread;
    wxString firsturl;
    jfFicURLParser uparse;
    // event handler table
    DECLARE_EVENT_TABLE()
};
/*****************************************************************************/
