/******************************************************************************
Name    :   dirupdate_thread.h
Author  :   John Q Metro
Purpose :   Declares the thread that does directory updates (intended for
              syncing directories of downloaded fanfics).
Created :   July 5, 2015
Updated :   July 6, 2015
******************************************************************************/
#ifndef DIRUPDATE_THREAD_H_INCLUDED
#define DIRUPDATE_THREAD_H_INCLUDED
#endif // DIRUPDATE_THREAD_H_INCLUDED
//----------------------------------
#ifndef DIRUPDATE_H_INCLUDED
  #include "../../core/utils/dirupdate.h"
#endif // DIRUPDATE_H_INCLUDED
#ifndef CORE_THREADS_H_INCLUDED
  #include "../../connect/core_threads.h"
#endif // CORE_THREADS_H_INCLUDED
#ifndef PROGRESSPANEL_H_INCLUDED
  #include "../../interface/threads/progresspanel.h"
#endif // PROGRESSPANEL_H_INCLUDED
/*****************************************************************************/
class jfDirUpdate_Thread : public jfCoreThread {
  public:
    // constructor
    jfDirUpdate_Thread();
    // implemented virtual methods
    virtual void SendDone(jfDown::ResultAction done_status);
    virtual wxThread::ExitCode Entry();
    // passing parameters
    void SetDirectories(wxString sdir_in, wxString tdir_in, jfProgressPanelSingle* ptarget);
  protected:
    // internal methods
    bool Startup();
    bool TextResults();
    bool DoUpdateActions();
    // INTERNAL DATA
    bool started;
    wxString sdirx, tdirx;
    jfDirectoryUpdater* dupdate_obj;
};
/*****************************************************************************/
