/******************************************************************************
Name    :   ffndown_thread.h
Author  :   John Q Metro
Purpose :   Declares the thread that downloads Fanfiction.Net fic parts
Created :   July 22, 2011
Updated :   July 7, 2016 (MediaMiner.Org changes)
******************************************************************************/
#ifndef FFNDOWN_THREAD_H_INCLUDED
#define FFNDOWN_THREAD_H_INCLUDED
#endif // FFNDOWN_THREAD_H_INCLUDED
//----------------------------------------
#ifndef FFNDOWN_DATA_H_INCLUDED
  #include "../data/ffndown_data.h"
#endif // FFNDOWN_DATA_H_INCLUDED
#ifndef FFNDOWN_PARTS_H_INCLUDED
  #include "../data/ffndown_parts.h"
#endif // FFNDOWN_PARTS_H_INCLUDED
#ifndef FFNDOWN_PARTS_H_INCLUDED
  #include "ffndown_parts.h"
#endif // FFNDOWN_PARTS_H_INCLUDED
#ifndef CORE_THREADS_H_INCLUDED
  #include "../../connect/core_threads.h"
#endif // CORE_THREADS_H_INCLUDED
//***************************************************************************
bool FFN_FicTruncated(const wxString* ival);
bool FIM_FicTruncated(const wxString* ival);
bool AO3_FicTruncated(const wxString* ival);
bool HPF_FicTruncated(const wxString* ival);
bool MMO_FicTruncated(const wxString* ival);
//------------------------------------------
bool FFN_FicMissing(const wxString* ival);
bool FIM_FicMissing(const wxString* ival);
bool HPF_FicMissing(const wxString* ival);
//================================================================================
// core thread for the Fanfiction.Net downloaders
class jfDownThreadCore : public jfDownloadThread {
  public:
    jfDownThreadCore();
    void SetFicData(jfFicDownParams* in_ficparams);
    // a reminder
    virtual wxThread::ExitCode Entry() = 0;
    virtual void SendDone(jfDown::ResultAction done_status);
  protected:
    // helper methods
    bool ProcessAndWrite();
    wxThread::ExitCode HandleCore();
    void TypeSetup();
    bool AO3_RCheck();
    // virtual plug-in methods to handle some vital bits
    virtual void PreFetch1();
    virtual void PreFetch2();
    virtual void SetUrl();
    virtual bool ProcessPage();
    virtual size_t NewPagecount() const =0;
    virtual void PostPageAction() = 0;
    // virtual method declarations
    virtual bool GetPages() = 0;
    virtual void MakeFanficObject() = 0;

    // internal data
    bool indexpage;
    jfFanfic* xqval;
    jfFicDownParams* ficparams;
};
//================================================================================
class jfDownThread : public jfDownThreadCore {
  public:
    jfDownThread();
    virtual wxThread::ExitCode Entry();
  protected:
    // helper methods
    virtual size_t NewPagecount() const;
    virtual void PostPageAction();
    virtual bool GetPages();
    virtual void MakeFanficObject();
    bool DoPageOne();
};
//=========================================================================
// Version 2 of the thread is for the fic downloader tool, where we start with only the URL
class jfDownThread2 : public jfDownThreadCore {
  public:
    jfDownThread2();
    virtual wxThread::ExitCode Entry();
  protected:
    // helper methods
    virtual size_t NewPagecount() const;
    virtual void PostPageAction();
    virtual bool GetPages();
    virtual void MakeFanficObject();
    // messages
    void SendInfoSignal() const;
};
//=================================================================================



//***************************************************************************
