/*****************************************************************************
Name    : googlecoll.h
Basic   : Defines the collection class for google items
Author  : John Q Metro
Started : September 29, 2009
Updated : August 22, 2012

******************************************************************************/
#ifndef GOOGLECOLL_H_INCLUDED
#define GOOGLECOLL_H_INCLUDED
#endif // GOOGLECOLL_H_INCLUDED
//------------------------------------------------------------------------------
#ifndef TYPEDCOLLECT_H_INCLUDED
  #include "../../core/structs/typedcollect.h"
#endif // TYPEDCOLLECT_H_INCLUDED
#ifndef GOOGLEOBJ_H_INCLUDED
  #include "googleobj.h"
#endif // GOOGLEOBJ_H_INCLUDED
#ifndef GOOGLESEARCH_H_INCLUDED
  #include "googlesearch.h"
#endif // GOOGLESEARCH_H_INCLUDED
/*****************************************************************************/
class jfGoogleCollection : public jfTypedCollection<jfGoogleItem> {
  public:
    jfGoogleCollection(jfGoogleSearch* sdata_in);
    // implemented page methods
    virtual wxString GetTypeID() const;
    virtual bool AddFirstPage(const wxString& inpage, size_t& outcount);
    virtual bool AddPage(const wxString& inpage, size_t& outcount);
    virtual bool LoadValues(jfSkeletonParser* inparser,size_t which) const;
    // the destructor
  protected:
    // internal parsing methods
    bool PageAndItemCount(jfStringParser* inparser, size_t& itemcount);
    size_t ProcessPage(const wxString& inpage);
    // some more virtual i/o methods
    virtual bool AddDelta(wxTextFile* outfile) const;
    virtual bool ReadDelta(jfFileReader* infile);
    // internal data
    jfGoogleSearch* sdata_typed;


};
/*****************************************************************************/
