/*****************************************************************************
Name    : googleinfo.cpp
Basic   : Defines extra data for google
Author  : John Q Metro
Started : January 3, 2010
Updated : January 3, 2010
Notes   :

******************************************************************************/
#ifndef GOOGLEINFO_H_INCLUDED
  #include "googleinfo.h"
#endif // GOOGLEINFO_H_INCLUDED
/*****************************************************************************/
GoogleInfo* m_google_info;
//=============================================================================
GoogleInfo::GoogleInfo() {
  lang_tags = NULL;
  lang_names = NULL;
  lang_count = 0;
  langset = false;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// getting language info
const wxArrayString* GoogleInfo::GetLangNames() {
  if (!langset) LoadFromConstants();
  return lang_names;
}
//------------------------------------------------------------------------
const wxString GoogleInfo::GetLangTag(size_t index) {
  if (!langset) LoadFromConstants();
  if (index>=lang_count) return wxEmptyString;
  else return (lang_tags->Item(index));
}
//----------------------------------------------------------------------
int GoogleInfo::GetIndexByTag(wxString intag) {
  // local variables
  wxString ctag;
  size_t loopc;
  // if the data has not been initialized, we do so
  if (!langset) LoadFromConstants();
  // looking for the tag
  for (loopc=0;loopc<lang_count;loopc++) {
    ctag = lang_tags->Item(loopc);
    if (ctag==intag) break;
  }
  // the result
  if (loopc==lang_count) return -1;
  else return loopc;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// destructor
GoogleInfo::~GoogleInfo() {
  if (lang_tags!=NULL) delete lang_tags;
  if (lang_names!=NULL) delete lang_names;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void GoogleInfo::LoadFromConstants() {
  // initial setup...
  if (lang_tags != NULL) lang_tags->Clear();
  else lang_tags = new wxArrayString();
  if (lang_names != NULL) lang_names->Clear();
  else lang_names = new wxArrayString();
  lang_count = fixcount;
  // now we loop and get the items
  for (size_t loopc = 0; loopc<fixcount; loopc++) {
    lang_tags->Add(glang[2*loopc]);
    lang_names->Add(glang[2*loopc+1]);
  }
  // done
  langset = true;
}
/*****************************************************************************/
