/*****************************************************************************
Name    : googleinfo.h
Basic   : Declares extra data for google
Author  : John Q Metro
Started : January 3, 2010
Updated : January 3, 2010
Notes   :

******************************************************************************/
#ifndef GOOGLEINFO_H_INCLUDED
#define GOOGLEINFO_H_INCLUDED
#endif // GOOGLEINFO_H_INCLUDED

#ifndef WX_PRECOMP
  #include <wx/wx.h>
#else
#include "wx/wxprec.h"
#endif

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

/*****************************************************************************/
// hard coded list of languageas for google advanced search
const size_t fixcount = 46;
const wxString glang[2*fixcount] = {
      wxT("")           ,wxT("any language"),wxT("lang_af")   ,wxT("Afrikaans"),
      wxT("lang_ar")    ,wxT("Arabic")      ,wxT("lang_hy")   ,wxT("Armenian"),
      wxT("lang_be")    ,wxT("Belarusian")  ,wxT("lang_bg")   ,wxT("Bulgarian"),
      wxT("lang_ca")    ,wxT("Catalan")     ,wxT("lang_zh-CN"),wxT("Chinese (Simplified)"),
      wxT("lang_zh-TW") ,wxT("Chinese (Traditional)"),wxT("lang_hr"),wxT("Croatian"),
      wxT("lang_cs"),wxT("Czech")     ,wxT("lang_da"),wxT("Danish"),
      wxT("lang_nl"),wxT("Dutch")     ,wxT("lang_en"),wxT("English")    ,wxT("lang_eo"),wxT("Esperanto"),
      wxT("lang_et"),wxT("Estonian")  ,wxT("lang_tl"),wxT("Filipino")   ,wxT("lang_fi"),wxT("Finnish"),
      wxT("lang_fr"),wxT("French")    ,wxT("lang_de"),wxT("German")     ,wxT("lang_el"),wxT("Greek"),
      wxT("lang_iw"),wxT("Hebrew")    ,wxT("lang_hu"),wxT("Hungarian")  ,wxT("lang_is"),wxT("Icelandic"),
      wxT("lang_id"),wxT("Indonesian"),wxT("lang_it"),wxT("Italian"),
      wxT("lang_ja"),wxT("Japanese")  ,wxT("lang_ko"),wxT("Korean")     ,wxT("lang_lv"),wxT("Latvian"),
      wxT("lang_lt"),wxT("Lithuanian"),wxT("lang_no"),wxT("Norwegian")  ,wxT("lang_fa"),wxT("Persian"),
      wxT("lang_pl"),wxT("Polish")    ,wxT("lang_pt"),wxT("Portuguese") ,wxT("lang_ro"),wxT("Romanian"),
      wxT("lang_ru"),wxT("Russian")   ,wxT("lang_sr"),wxT("Serbian")    ,wxT("lang_sk"),wxT("Slovak"),
      wxT("lang_sl"),wxT("Slovenian") ,wxT("lang_es"),wxT("Spanish")    ,wxT("lang_sw"),wxT("Swahili"),
      wxT("lang_sv"),wxT("Swedish")   ,wxT("lang_th"),wxT("Thai")       ,wxT("lang_tr"),wxT("Turkish"),
      wxT("lang_uk"),wxT("Ukrainian") ,wxT("lang_vi"),wxT("Vietnamese")};
//=============================================================================
// holds special google data
class GoogleInfo : public wxObject {
  public:
    // the constructor
    GoogleInfo();
    // getting language info
    const wxArrayString* GetLangNames();
    const wxString GetLangTag(size_t index);
    int GetIndexByTag(wxString intag);
    // destructor
    ~GoogleInfo();
  private:
    // helper methods
    void LoadFromConstants();
    // internal language data
    size_t lang_count;
    wxArrayString* lang_tags;
    wxArrayString* lang_names;
    bool langset;
};
//===========================================================================
extern GoogleInfo* m_google_info;
/*****************************************************************************/
