/*****************************************************************************
Name    : googleobj.h
Basic   : Declares a class for holding a google item
Author  : John Q Metro
Started : September 9, 2009
Updated : January 3, 2015
Notes   :

******************************************************************************/
#ifndef GOOGLEOBJ_H_INCLUDED
#define GOOGLEOBJ_H_INCLUDED
#endif // GOOGLEOBJ_H_INCLUDED
//----------------------------------------------------------------------------
#ifndef BASEOBJ_H_INCLUDED
    #include "../../core/objs/baseobj.h"
#endif // BASEOBJ_H_INCLUDED
#ifndef UTILS2_H_INCLUDED
  #include "../../core/utils/utils2.h"
#endif // UTILS2_H_INCLUDED
/*****************************************************************************/
enum jfGOOITYPE {jfGIT_DEFAULT, jfGIT_VIDEO, jfGIT_BOOK};
//--------------------------------------------------------
class jfGoogleItem : public jfBasePD {
  public:
    // constructors
    jfGoogleItem();
    jfGoogleItem(const wxString& insrc, size_t setrank);
    jfGoogleItem(const jfGoogleItem& src);
    // implemented public virtual methods
    virtual wxString GetTypeID() const;
    virtual bool LoadValues(jfSkeletonParser* inparser) const;
    virtual void ProcessDescription();
    // to string functions
    virtual wxString ToText() const;
    virtual wxString ToHTML() const;
    virtual wxString ToDisplayHTML() const;
    // additional methods
    bool SetFromString(wxString indata, size_t setrank);
    // the destructor
    ~jfGoogleItem();
  protected:
    // implemented private virtual methods
    virtual bool AddRestToFile(wxTextFile* outfile) const;
    virtual bool ReadRestFromFile(jfFileReader* infile);
    // parser helping methods
    bool ExtractUrl(wxString& olink, wxString& oerror);
    // internal data
    wxString rawhtml;
    jfGOOITYPE gtype;
    // links
    wxString cached, similar;
};
/*****************************************************************************/
