/******************************************************************************
Name    :   g_mainpanel1.h
Author  :   John Q Metro
Purpose :   Declares the main panels for google searching
Created :   October 11, 2009
Updated :   September 26, 2012
******************************************************************************/
#ifndef G_MAINPANEL1_H_INCLUDED
#define G_MAINPANEL1_H_INCLUDED
#endif // G_MAINPANEL1_H_INCLUDED
//-----------------------------------------------------------------------------
#ifndef DISPLAY_BASE_H_INCLUDED
  #include "../../interface/display/display_base2.h"
#endif // DISPLAY_BASE_H_INCLUDED
#ifndef G_PANEL1_H_INCLUDED
  #include "g_panel1.h"
#endif // G_PANEL1_H_INCLUDED
#ifndef GOOGLESEARCH_H_INCLUDED
  #include "../data/googlesearch.h"
#endif // GOOGLESEARCH_H_INCLUDED
/*****************************************************************************/
class jfGoogleSearchGrp : public jfSearchGrouping {
  public:
    // the constructor
    jfGoogleSearchGrp(wxWindow* parent, wxWindowID id, jfGoogleSearch* searchin, const wxString& name = wxT("jfGoogleSearchGrp"));
    // custom  methods
    virtual jfSearchPanelBase*  MakeFirstPanel(wxWindowID id_in);
    virtual jfSearchCore*       MakeTypedSearch() const;
    virtual jfResultCollection* MakeTypedCollection() const;
    virtual jfSingleSearchThreadBase* MakeTypedThread() const;
  protected:
    virtual void MoreResized(size_t x, size_t y);
    jfGoogleSearch* typed_search;
};
//===========================================================================
class jfGoogleOnePanelSearch : public jfOnePanelSearch {
  public:
    // the constructor
    jfGoogleOnePanelSearch(wxWindow* parent, wxWindowID id, jfGoogleSearch* searchin, const wxString& name = wxT("jfGoogleOnePanelSearch"));
    // custom  methods
    virtual jfSearchPanelBase*  MakeFirstPanel(wxWindowID id_in);
    virtual jfSearchCore*       MakeTypedSearch() const;
    virtual jfResultCollection* MakeTypedCollection() const;
    virtual jfSingleSearchThreadBase* MakeTypedThread() const;
  protected:
    virtual void MoreResized(size_t x, size_t y);
    jfGoogleSearch* typed_search;
};
//****************************************************************************
class jfGoogleMain : public jfMainSearchGroup {
  public:
    // the constructor
    jfGoogleMain(wxWindow* parent, wxWindowID id, jfSearchCore* searchin, bool notebook=true);
    // right click menu event handlers
    void OnRMenuAppendUrl(wxCommandEvent& event);
  protected:
    // implemented virtual method
    virtual jfSearchGroupingCore* MakeSearchGroup(wxWindowID xid, jfSearchCore* xnewsearch, bool threepanels);
    virtual jfResultDisplay* MakeResultGroup(wxWindow* inparent,wxWindowID id = wxID_ANY);
  // internal data
   // jfGoogleSearchGrp* typed_mpanel;
  // event table hander
  DECLARE_EVENT_TABLE()
};
/*****************************************************************************/
