/******************************************************************************
Name    :   g_panel1.h
Author  :   John Q Metro
Purpose :   Declares the custom first panel for google searching
Created :   October 11, 2009
Updated :   March 17, 2010
******************************************************************************/
#ifndef G_PANEL1_H_INCLUDED
#define G_PANEL1_H_INCLUDED
#endif // G_PANEL1_H_INCLUDED
//-------------------------------------------
#ifndef DISPLAY_BASE_H_INCLUDED
  #include "../../interface/display/display_base.h"
#endif // DISPLAY_BASE_H_INCLUDED
#ifndef GOOGLESEARCH_H_INCLUDED
  #include "../data/googlesearch.h"
#endif // GOOGLESEARCH_H_INCLUDED
/*****************************************************************************/
const wxString goourlfilter = wxT("Embedded Google URL Filter");
class jfGoogleDFE : public jfDefaultFilterEditorBase {
  public:
    // the constructor
    jfGoogleDFE(wxWindow* parent,wxWindowID id, jfSearchCore* inobj);
  protected:
		// internal constant methods
    // implemented virtual methds
    virtual bool SaveFiltersExtended();
    virtual bool ChangeSearchExtended(jfSearchCore* obj_data);
    // an additional url filter
    jfUrlFilEdit* g_urledit;

};
//==============================================================================
class jfGooglePanel1 : public jfSearchPanelBase {
  public:
    // the constructor
    jfGooglePanel1(wxWindow* parent, jfGoogleSearch* insearch, wxWindowID id = wxID_ANY, const wxString& name = wxT("jfGooglePanel1"));
    // other external methods
    virtual bool LoadToObj();
    virtual bool ChangeObj(jfSearchCore* obj_data);
  protected:
    virtual jfDefaultFilterEditorBase* MakeTypedFilEdit();
    // setting up the entry data
    void MakeArrangeEntry();
    // gui entry data
    wxStaticText* includes_label;
    wxTextCtrl* includes_edit;
    wxStaticText* alternates_label;
    wxTextCtrl* alternates_edit;
    wxStaticText* excludes_label;
    wxTextCtrl* excludes_edit;
    wxStaticText* sitesearch_label;
    wxTextCtrl* sitesearch_edit;
    wxStaticText* langpicker_label;
    wxChoice* langpicker;
    // the sizers
    wxBoxSizer* row1,*row2,*row3,*row4;
    wxBoxSizer* stack;
};
/*****************************************************************************/
