/******************************************************************************
// Name:        googlethreads.cpp
// Author :     John Q Metro
// Purpose :    Defines the custom thread for google page fetching and parsing
// Created:     October 11, 2009
// Updated:     January 8, 2014
*******************************************************************************/
#ifndef GOOGLETHREADS_H_INCLUDED
  #include "googlethreads.h"
#endif // GOOGLETHREADS_H_INCLUDED
#ifndef UTILS1_H_INCLUDED
  #include "../../core/utils/utils1.h"
#endif // UTILS1_H_INCLUDED
#ifndef LOGGING_H_INCLUDED
  #include "../../core/utils/logging.h"
#endif // LOGGING_H_INCLUDED

//******************************************************************************
jfGoogleThread::jfGoogleThread():jfSingleSearchThreadBase() {
  maindata = NULL;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
wxThread::ExitCode jfGoogleThread::Entry() {
  // local variables
  const wxString fname = wxT("jfGoogleThread::Entry");
  wxString ztext;
  bool xval;
  // starting
  threadname = wxT("GOOGLE");
  /**/TLog(fname,1);
  // startup messages
  SendStart();
  epagecount = 10;
  SendLabels(wxT("Result Page"),wxT("Fetching"));
  SendTotalCount(epagecount);
  maindata = dynamic_cast<jfGoogleResColl*>(search_results);
  /**/TLog(fname,2);
  // getting stuff
  xval = LoopGet();
  if (xval) SendEnd();
  return 0;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// virtual plug-in methods to handle some vital bits
//--------------------------------------------------
void jfGoogleThread::PreFetch1() {
  SendNewItem(pageindex,epagecount);
}
//--------------------------------------------------
void jfGoogleThread::PreFetch2() {}
//--------------------------------------------------
void jfGoogleThread::SetUrl() {
  fetchurl = main_search->GetIndexUrl(pageindex);
}
//--------------------------------------------------
bool jfGoogleThread::ProcessPage() {
  bool rval;
  if (pageindex==1) {
    rval = maindata->CreateItemCollection(*page_data, err_string);
  }
  else rval = maindata->AddPage(*page_data, err_string);
  return rval;
}
//--------------------------------------------------
size_t jfGoogleThread::NewPagecount() const {
  return maindata->PageTotal();
}
//--------------------------------------------------
void jfGoogleThread::PostPageAction() {}
//******************************************************************************
