/******************************************************************************
// Name:        googlethreads.h
// Author :     John Q Metro
// Purpose :    Declares the custom thread for google page fetching and parsing
// Created:     October 8, 2009
// Updated:     January 7, 2014
*******************************************************************************/

#ifndef GOOGLETHREADS_H_INCLUDED
#define GOOGLETHREADS_H_INCLUDED
#endif // GOOGLETHREADS_H_INCLUDED

#ifndef MORE_THREADS_H_INCLUDED
  #include "../../connect/more_threads.h"
#endif // MORE_THREADS_H_INCLUDED

#ifndef GOOGLESEARCH_H_INCLUDED
  #include "../data/googlesearch.h"
#endif // GOOGLESEARCH_H_INCLUDED

/******************************************************************************/
class jfGoogleThread : public jfSingleSearchThreadBase {
  public:
    jfGoogleThread();
    virtual wxThread::ExitCode Entry();
  protected:
    // virtual plug-in methods to handle some vital bits
    virtual void PreFetch1();
    virtual void PreFetch2();
    virtual void SetUrl();
    virtual bool ProcessPage();
    virtual size_t NewPagecount() const;
    virtual void PostPageAction();
    // internal data
    jfGoogleResColl* maindata;
};

/******************************************************************************/
