/***************************************************************
 * Name:      initend.h
 * Purpose:   Haeder for some special startup and shutdown methods
 * Author:    John Q Metro (johnqmetro@hotmail.com)
 * Created:   Febuary 13, 2011
 * Updated:   July 23, 2015
 *
 **************************************************************/
#ifndef INITEND_H_INCLUDED
#define INITEND_H_INCLUDED
#endif // INITEND_H_INCLUDED
//------------------------------
#include <wx/arrstr.h>
#include <wx/datetime.h>
#include <wx/thread.h>
#include <wx/frame.h>
//------------------------------
#if defined(_MSC_VER)
  #define uint64_t unsigned __int64
#else
  #include <inttypes.h>
#endif
//****************************************************************
/* Generally used for default directories...
0: Google Results
1: Google Save Files
2: FFN Results
3: FFN Save Files
4: FFN Saved Fics
*/
namespace globalsettings {
  // variables
  extern bool dologging;
  extern bool logchange;
  extern size_t ficsize_hint;
  extern wxArrayString* globaldirs;
  extern size_t fimlimits[];
  extern bool catobtained;
  // extras for keeping track of downloads
  extern uint64_t totaldown;
  extern size_t reset_day;
  extern wxDateTime month_later;
  extern wxFrame* topwindow;
  extern wxMutex down_mutex;
  // fim contstants
  // constants
  const size_t GV_NUMVALS = 8;
  const wxString gv_dirlabels[GV_NUMVALS] = {wxT("Google Results"),wxT("Google Save Files"),
        wxT("Search Results"),wxT("Save Files"),wxT("Downloaded Fanfics"),
        wxT("Default Open Directory"),wxT("Default Source for syc"),
        wxT("Default Destination for sync")};
  // methods
  bool LoadSettings();
  void SetToDefault(bool filldirs);
  size_t TestGlobalDirs();
  bool LoadAllSettings();
  bool SaveSettings();
  wxString GSaveDir(bool is_google);
  // extra methods for download quantity tracking
  bool SetZeroDate(size_t in_reset_day);
  bool SetZeroNow();
}

//===============================================
// changes the working directory to the executable directory
bool ChangeWDir(wxString subdir = wxEmptyString);
//===============================================
bool LoadAtStart();
//---------------------
bool WriteAtFinish();
//****************************************************************
