/******************************************************************************
Name    :   display_base1.h
Author  :   John Q Metro
Purpose :   Main result/Search Interface, 3 tab version
Created :   September 22, 2012
Updated :   December 21, 2013
******************************************************************************/
#ifndef DISPLAY_BASE1_H_INCLUDED
#define DISPLAY_BASE1_H_INCLUDED
#endif // DISPLAY_BASE1_H_INCLUDED
//----------------------------------------
#include <wx/panel.h>
#include <wx/filepicker.h>
//--------------------------------------------
#ifndef SEARCHCORE_H_INCLUDED
  #include "../../core/objs/searchcore.h"
#endif // SEARCHCORE_H_INCLUDED
#ifndef FILTER_EDITOR_H_INCLUDED
  #include "../filters/base/filter_editor.h"
#endif // FILTER_EDITOR_H_INCLUDED
#ifndef CATEGORY_LISTEDIT_H_INCLUDED
  #include "../filters/base/category_listedit.h"
#endif // CATEGORY_LISTEDIT_H_INCLUDED
#ifndef WIDGETS3_H_INCLUDED
  #include "../misc/widgets3.h"
#endif // WIDGETS3_H_INCLUDED
#ifndef DISPLAY_BASE_H_INCLUDED
  #include "display_base.h"
#endif // DISPLAY_BASE_H_INCLUDED
/*****************************************************************************/
class jfPanelTwo : public wxPanel {
  public:
    // the constructor
    jfPanelTwo(wxWindow* parent, wxWindowID id, jfSearchCore* onsearch,
        const wxArrayString* infclist, const wxString& name = wxT("jfPanelTwo"));
    // returning data
    jfSearchCore* GetSearchObj();
    bool UpdateSearchData();
    wxString GetDisplayName() const;
		// special methods
		void NameChangeEvent(wxCommandEvent& event);
		void HandleNewDirectory(wxFileDirPickerEvent& inevent);
    virtual void WindowResized(size_t x, size_t y);
  protected:
    void FinishConstruction();
    // the main panels
    jfFilterMapEditor*        panel2;
    jfMainCategoriesEditor*   panel3;
    // other gui elements
    wxNotebook* panel_holder;
    jfNameDescEditor* nam_desc_e;
    jfDirPicker* dirpicker;
    // the sizer
    wxBoxSizer* top_sizer;
    // internal data
    jfSearchCore* searchdata_link;
    bool ninit;
    // external data
    const wxArrayString* fclist;
	// the event handline declaration
	DECLARE_EVENT_TABLE()
};
//===============================================================================
class jfOnePanelSearch : public jfSearchGroupingCore {
  public:
    // the constructor
    jfOnePanelSearch(wxWindow* parent, wxWindowID id, const wxString& name = wxT("jfOnePanelSearch"));
    // custom  methods
    virtual jfSearchPanelBase*  MakeFirstPanel(wxWindowID id_in) = 0;
    virtual jfSearchCore*       MakeTypedSearch() const = 0;
    virtual jfResultCollection* MakeTypedCollection() const = 0;
    virtual jfSingleSearchThreadBase* MakeTypedThread() const = 0;
    // returning data
    virtual bool UpdateSearchData();
		// special methods
    virtual void WindowResized(size_t x, size_t y);
  protected:
    virtual void FinishConstruction();
    virtual void MoreResized(size_t x, size_t y) = 0;
    // the main panels
    jfSearchPanelBase*        panel1;
    // the sizer
    wxBoxSizer* top_sizer;
    // internal data
    bool custinit;
};
/*****************************************************************************/
