/******************************************************************************
Name    :   display_base2.h
Author  :   John Q Metro
Purpose :   Split from display_base.h on Sept 13, 2012
Created :   August 23, 2009
Updated :   July 1, 2015
******************************************************************************/
#ifndef DISPLAY_BASE2_H_INCLUDED
#define DISPLAY_BASE2_H_INCLUDED
#endif // DISPLAY_BASE2_H_INCLUDED
//----------------------------------------
#ifndef DISPLAY_BASE_H_INCLUDED
  #include "display_base.h"
#endif // DISPLAY_BASE_H_INCLUDED
#ifndef DISPLAY_BASE1_H_INCLUDED
  #include "display_base1.h"
#endif // DISPLAY_BASE1_H_INCLUDED
//---------------------------------
#ifndef RESULT_PANEL_H_INCLUDED
  #include "result_panel.h"
#endif // RESULT_LISTBOX_H_INCLUDED
#ifndef FICMARKING_H_INCLUDED
  #include "../../core/structs/ficmarking.h"
#endif // FICMARKING_H_INCLUDED
//******************************************************************************/
class DisplayPanelCore : public wxPanel {
  public:
    // we need a constructor
    DisplayPanelCore(wxWindow* parent, wxWindowID id, wxString inname);
    // shared virtual methods
    virtual bool WriteAll2Html() =0;
    virtual bool WriteCurrent2Html() =0;
    virtual void WindowResized(size_t x, size_t y) = 0;
  protected:
};
//===========================================================================
class jfMainSearchGroup : public DisplayPanelCore {
  public:
    // the constructor
    jfMainSearchGroup(wxWindow* parent, wxWindowID id, jfSearchCore* searchin, rtype_enum rinval, bool notebook, bool multiple );
    // event handlers
    void StartButton(wxCommandEvent& event);
    void PPSearchDoneSignal(wxCommandEvent& event);
    void PPSearchFailSignal(wxCommandEvent& event);
    // right click menu event handlers
    void OnRMenuAppendText(wxCommandEvent& event);
    void OnMarkDiscard(wxCommandEvent& event);
    // status data
    bool InProgress() const;
    bool CStop();
    wxString GetSearchName() const;
    wxString GetDisplayName() const;
    // doing output
    virtual bool WriteAll2Html();
    virtual bool WriteCurrent2Html();
    bool SaveToFile(wxString fname);
    bool SaveToFile();
    bool HasBeenSaved() const;
    // other methods
    jfSearchCore* GetSearchPointer();
    virtual void WindowResized(size_t x, size_t y);
  protected:
    // internal methods
    virtual jfSearchGroupingCore* MakeSearchGroup(wxWindowID xid, jfSearchCore* newsearch, bool threepanels) = 0;
    virtual jfResultDisplay* MakeResultGroup(wxWindow* inparent, wxWindowID id = wxID_ANY) = 0;
    void TopArranger();
    void MakeThreadCollection();
    bool BuildSearch();
    void ClearOldData();
    void SendNotDoneSignal();
    wxString GSearchName() const;
    bool ConsStepTwo(const wxArrayString* infclist);
    void SetFicMark(size_t xindex, jf_FicMark mkval, size_t c_index, size_t i_index);
    // gui elements
    bool noteb;
    bool threepanel;
    jfSearchGroupingCore* p_search;
    jfResultDisplay*  r_panel;
    jfPanelTwo* panel_two;
    wxNotebook*  container;
    // the one and only sizer
    wxBoxSizer* top_sizer;
    // internal data
    bool launched;
    jfResultCollection* results;
    jfSingleSearchThreadBase* thread_holder;
    jfSearchCore* search_data;
    jfDownloadParams* thread_constants;
    // save data
    bool beensaved;
    wxString savfpath;
    wxDateTime starttime;
    // menu data
    jfPopupMenu* rc_menu;
    // the event handline declaration
    DECLARE_EVENT_TABLE()

};
//******************************************************************************/
