/*****************************************************************************
Name:        result_panel.h
Author :     John Q Metro
Purpose :    Declares a panel for displaying search results
Created:     July 26, 2009
Updated:     January 8, 2014
******************************************************************************/
#ifndef RESULT_PANEL_H_INCLUDED
#define RESULT_PANEL_H_INCLUDED

#endif // RESULT_PANEL_H_INCLUDED
//-----------------------------------------------------------------------------
#ifndef TYPED_DISPLAY_H_INCLUDED
  #include "typed_display.h"
#endif // TYPED_DISPLAY_H_INCLUDED
#ifndef CATEGORIES_H_INCLUDED
  #include "../../core/structs/categories.h"
#endif // CATEGORIES_H_INCLUDED
#ifndef VECTORS_H_INCLUDED
  #include "../../core/vectors.h"
#endif // VECTORS_H_INCLUDED
#ifndef PROGRESSPANEL_H_INCLUDED
  #include "../threads/progresspanel.h"
#endif // PROGRESSPANEL_H_INCLUDED
#ifndef MULTIPANEL_H_INCLUDED
  #include "../threads/multipanel.h"
#endif // MULTIPANEL_H_INCLUDED
#ifndef SEARCHCORE_H_INCLUDED
  #include "../../core/objs/searchcore.h"
#endif // SEARCHCORE_H_INCLUDED
#ifndef MENU_H_INCLUDED
  #include "../misc/menu.h"
#endif // MENU_H_INCLUDED
//------------------------------------------------------------------------------
#include <wx/notebook.h>
//*****************************************************************************
enum rtype_enum { rtype_BASIC,rtype_FFN,rtype_MCNU };
//===========================================================================
/* here, we group a jfResultPanel with a progress panel to have something that
shows status in general */
class jfResultDisplay: public wxPanel {
  public:
    // constructor
    jfResultDisplay(wxWindow* parent, jfMainSearchGroup* toplevel, rtype_enum rinval,wxWindowID id = wxID_ANY,header_enum inval=he_NONEMPTY);
    // creating the result displays and returning the links
    bool LoadGetLinks(jfSearchCore* results);
    // functions to return info that has to be passed to the search thread
    jfNewPauser* GetPauser();
    jfProgressPanelBase*  GetProgressPanel();
    // additional data to set
    void SetPopupMenu(jfPopupMenu* inmenu);
    // we call this when we want to clear old results
    void ClearOld();
		// this is generally called when a search is aborted
		void SearchAbort();
    // some status and clearing methods
    bool InProgress() const;
    bool CStop();
    size_t SelectedIndex() const;
    void WindowResized(size_t x, size_t y);
  private:
    // gui elements
    jfHtmlResultCollection* mainviewer;
    jfProgressPanelBase* progpanel;
    // sizers
    wxBoxSizer* topsizer;
    // internal data
    bool started;
    bool ssize;
    jfPopupMenu* p_menu;
};
//*****************************************************************************
