/*****************************************************************************
Name:        typed_display.h
Author :     John Q Metro
Purpose :    Typed HTML Listbox results
Created:     April 27, 2011
Updated:     November 30, 2013
******************************************************************************/
#ifndef TYPED_DISPLAY_H_INCLUDED
#define TYPED_DISPLAY_H_INCLUDED
#endif // TYPED_DISPLAY_H_INCLUDED
#ifndef HTML_DISPLAY_H_INCLUDED
  #include "html_display.h"
#endif // HTML_DISPLAY_H_INCLUDED
#ifndef FFN_INDEX_H_INCLUDED
  #include "../results/ffn_index.h"
#endif // FFN_INDEX_H_INCLUDED
//-------------------------------------------
/*****************************************************************************/
class jfHtmlResultCollection_Base : public jfHtmlResultCollection {
  public:
    // constructor
    jfHtmlResultCollection_Base(header_enum inhtype, wxWindow* parent, wxWindowID id);
    // special events
    virtual void AddCategory(wxCommandEvent& event);
    virtual void AddResults(wxCommandEvent& event);
  protected:
    // helper methods
    virtual jfDisplayIndexGroup* MakeIndexers();
    // other stuff
    jfDisplayIndex_Basic* typed_group;
};
//=========================================================================
class jfHtmlResultCollection_FFN : public jfHtmlResultCollection {
  public:
    // constructor
    jfHtmlResultCollection_FFN(wxWindow* parent,wxWindowID id);
    // special events
    virtual void AddCategory(wxCommandEvent& event);
    virtual void AddEmptyCategories(wxCommandEvent& event);
    virtual void AddResults(wxCommandEvent& event);
    void NextUpdateCategory(wxCommandEvent& event);
    void UpdatedFic(wxCommandEvent& event);
    void InsertSignal(wxCommandEvent& event);
    // custom methods
    bool SetInsertMode(bool inmode);
  protected:
    // helper methods
    virtual jfDisplayIndexGroup* MakeIndexers();
    void CreateUpdateLabels();
    void NullUpdateLabels();
    void UpdateNewLabel();
    void ChangeUpdateLabel(bool updated);
    // other stuff
    jfDisplayIndex_FFN* typed_group;
    bool insert_mode;
    // update related count values
    size_t new_items;
    size_t updated_items;
    size_t missing_items;
    // extra labels for insert mode displays
    wxStaticText* new_label;
    wxStaticText* updated_label;
    wxStaticText* missing_label;
    // the event table
    DECLARE_EVENT_TABLE()
};
/*****************************************************************************/
