//***************************************************************************
// Name:        ao3_sexpeditors.h
// Author :     John Q Metro
// Purpose :    Additional filter editors specific to archiveofourown.org
// Created:     September 8, 2012
// Updated:     March 16, 2014
//***************************************************************************
#ifndef AO3_SEXPEDITORS_H_INCLUDED
#define AO3_SEXPEDITORS_H_INCLUDED
#endif // AO3_SEXPEDITORS_H_INCLUDED
//-----------------------------------------------
#ifndef AO3_STRINGFILTERS_H_INCLUDED
  #include "../../../core/filters/ao3/ao3_stringfilters.h"
#endif // AO3_STRINGFILTERS_H_INCLUDED
#ifndef SFILT_EDIT_H_INCLUDED
  #include "../base/sfilt_edit.h"
#endif // SFILT_EDIT_H_INCLUDED
#ifndef FILTERS_EDIT1_H_INCLUDED
  #include "../extended/filters_edit1.h"
#endif // FILTERS_EDIT1_H_INCLUDED
//***************************************************************************
/* a wrapper for jfSimpleExprEdit that is for an character filter */
class jfExtraTagFilterEditor : public jfSimpleSFilterEditor {
  public:
    // the default constructor
    jfExtraTagFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfExtraTagFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfExtraTagsFilterEditor"));
  protected:
    // internal methods
    virtual jfSimpleExpFilterCore* MakeTypedFilter(jfSimpleExpr* inpval);
};
//======================================================================
class jfAO3FandomFilterEditor : public jfBaseFilterEditor {
  public:
    // constructor
      jfAO3FandomFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfAO3FandomFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfAO3FandomFilterEditor"));
    // implemented virtual methods
      virtual void LoadFilter(const jfBaseFilter* infilter);
      virtual jfBaseFilter* GetFilter();
    // checking
      bool GeneralCheck() const;
    // event handlers
      void HandleCrossoverCheck(wxCommandEvent& event);
  protected:
    // internal setup methods
      void MakeWidgets();
      void ArrangeSizers2();
    // GUI elements
      wxCheckBox* crossover_box;
      wxCheckBox* allmatch_box;
      wxStaticText* perf_label;
      jfSimpleExprEdit* perf_edit;
      wxStaticText* main_label;
      jfSimpleExprEdit* main_edit;
    // sizers
      wxBoxSizer* csizer;
      wxBoxSizer* msizer;
    // internal data
      const jfAO3FandomFilter* typed_fpointer;

      DECLARE_EVENT_TABLE()
};
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// AO3 Kudo count filter editor, a wrapper for jfMinMaxUPanel
class jfAO3KudoFilterEditor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfAO3KudoFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfBaseFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfAO3KudoFilterEditor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    // checking
    bool GeneralCheck() const;
  private:
    jfMinMaxUPanel* insert_panel;
};
//***************************************************************************
