/******************************************************************************
Name    :   ao3_special1.cpp
Author  :   John Q Metro
Purpose :   Declares some base class for filter diting
Created :   September 10, 2012
Updated :   September 10, 2012
******************************************************************************/
#ifndef AO3_SPECIAL1_H_INCLUDED
  #include "ao3_special1.h"
#endif // AO3_SPECIAL1_H_INCLUDED
//--------------------------------------------
#ifndef AO3_FICOBJ_H_INCLUDED
  #include "../../../fanfic/data/ao3/ao3_ficobj.h"
#endif // AO3_FICOBJ_H_INCLUDED
#ifndef AO3_SPECIALS1_H_INCLUDED
  #include "../../../core/filters/ao3/ao3_specials1.h"
#endif // AO3_SPECIALS1_H_INCLUDED
#ifndef AO3_CONSTS_H_INCLUDED
  #include "../../../fanfic/data/ao3/ao3_consts.h"
#endif // AO3_CONSTS_H_INCLUDED
#ifndef LOGGING_H_INCLUDED
  #include "../../../core/utils/logging.h"
#endif // LOGGING_H_INCLUDED
/*****************************************************************************/
const wxChar* ratinglist[] = { wxT("General"),wxT("Teen"),wxT("Mature"),wxT("Explicit"),wxT("Unspecified")};
const wxChar* orientlist[] = { wxT("Femslash"),wxT("General"),wxT("Heterosexual"),wxT("Multiple"),
      wxT("Other"),wxT("Slash"),wxT("Unspecified")};
//=============================================================================
jfAO3_RatingFilterEditor::jfAO3_RatingFilterEditor(wxWindow* parent,const jfBaseFilter* infilt,
          const jfFilterMap* infmap, wxWindowID id, const wxString& name):
          jfBaseFilterEditor(parent,infmap,infilt,id,name) {
  // we start...
  // we create the insert.. the *actual*  editor
  insert_panel = new jfCharCheckBoxGroup(this,-1,wxT("Ratings"),5,ratinglist,ao3con::rating_ac,3);
  // finalizing things
  insert = new wxBoxSizer(wxVERTICAL);
  insert->Add(insert_panel,1,wxALL|wxEXPAND,2);
  // calling the sizers
  ArrangeSizers();
  if (infilt!=NULL) LoadFilter(infilt);
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// implemented virtual methods
//-------------------------------------
void jfAO3_RatingFilterEditor::LoadFilter(const jfBaseFilter* infilter) {
  assert(infilter!=NULL);
  filt_pointer = infilter;
  const jfAO3RatingFilter* temp = dynamic_cast<const jfAO3RatingFilter*>(infilter);
  insert_panel->SetFromString(temp->ToString());
  NameLoad();
}
//-------------------------------------
jfBaseFilter* jfAO3_RatingFilterEditor::GetFilter() {
  jfAO3RatingFilter* result = new jfAO3RatingFilter(insert_panel->GetStringValue());
  namedesc_edit->ChangeObj(result);
  return result;
}
//--------------------------------------------------------------
bool jfAO3_RatingFilterEditor::GeneralCheck() const {
  return true;
}
//=============================================================================
jfAO3_OrientFilterEditor::jfAO3_OrientFilterEditor(wxWindow* parent,const jfBaseFilter* infilt,
          const jfFilterMap* infmap, wxWindowID id, const wxString& name):
          jfBaseFilterEditor(parent,infmap,infilt,id,name) {
  // we start...
  // we create the insert.. the *actual*  editor
  insert_panel = new jfCharCheckBoxGroup(this,-1,wxT("Sexual Orientation"),7,orientlist,ao3con::orient_ac,3);
  // finalizing things
  insert = new wxBoxSizer(wxVERTICAL);
  insert->Add(insert_panel,1,wxALL|wxEXPAND,2);
  // calling the sizers
  ArrangeSizers();
  if (infilt!=NULL) LoadFilter(infilt);
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// implemented virtual methods
//-------------------------------------
void jfAO3_OrientFilterEditor::LoadFilter(const jfBaseFilter* infilter) {
  assert(infilter!=NULL);
  filt_pointer = infilter;
  const jfAO3OrientationFilter* temp = dynamic_cast<const jfAO3OrientationFilter*>(infilter);
  /**/jfXLogMessage(wxT("jfAO3_OrientFilterEditor::LoadFilter"),1,temp->ToString());
  insert_panel->SetFromString(temp->ToString());
  NameLoad();
}
//-------------------------------------
jfBaseFilter* jfAO3_OrientFilterEditor::GetFilter() {
  jfAO3OrientationFilter* result = new jfAO3OrientationFilter(insert_panel->GetStringValue());
  namedesc_edit->ChangeObj(result);
  return result;
}
//--------------------------------------------------------------
bool jfAO3_OrientFilterEditor::GeneralCheck() const {
  return true;
}
/*****************************************************************************/
