/******************************************************************************
Name    :   ao3_special2.h
Author  :   John Q Metro
Purpose :   Declares some interface panels for some AO3 Filters
Created :   October 6, 2012
Updated :   October 10 2012
******************************************************************************/
#ifndef AO3_SPECIAL2_H_INCLUDED
#define AO3_SPECIAL2_H_INCLUDED
#endif // AO3_SPECIAL2_H_INCLUDED
//---------------------------------
#ifndef AO3_SPECIALS2_H_INCLUDED
  #include "../../../core/filters/ao3/ao3_specials2.h"
#endif // AO3_SPECIALS2_H_INCLUDED
#ifndef WIDGETS3_H_INCLUDED
  #include "../../misc/widgets3.h"
#endif // WIDGETS3_H_INCLUDED
#ifndef BFILT_EDIT_H_INCLUDED
  #include "../base/bfilt_edit.h"
#endif // BFILT_EDIT_H_INCLUDED
#ifndef CHARO_EDITOR_H_INCLUDED
  #include "../../misc/charo_editor.h"
#endif // CHARO_EDITOR_H_INCLUDED
/*****************************************************************************/
class jfAO3PairingPanel : public wxPanel {
  public:
    // constructor
    jfAO3PairingPanel(wxWindow* parent, wxWindowID id, bool orient, const wxString& name = wxT("AO3PairingPanel"));
    // i/o
    bool SetFromString(const wxString& inval);
    void SetAlternateCheck(bool cval);
    wxString GetStringValue() const;
    bool GetAlternateCheck() const;
    // filter based i/o
    jfAO3PairFilter* GetFilter() const;
    bool StoreToFilter(jfAO3PairFilter* outval);
    bool LoadFromFilter(const jfAO3PairFilter* inval);
  protected:
    // GUI data
    wxCheckBox* altbox;
    jfLabeledEdit* pairlistbox;
    wxBoxSizer* bsizer;
    // non gui data
    size_t omode;
};
//=============================================================
// ao3 ratings filter editor
class jfAO3_PairingFilterEditor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfAO3_PairingFilterEditor(wxWindow* parent,const jfBaseFilter* infilt, const jfFilterMap* infmap,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("AO3RatingFilterEditor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    virtual bool GeneralCheck() const;
  protected:
    jfAO3PairingPanel* insert_panel;
};
//====================================================================
// ao3 ratings filter editor
class jfAO3_WarnFilterEditor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfAO3_WarnFilterEditor(wxWindow* parent,const jfBaseFilter* infilt, const jfFilterMap* infmap,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("AO3_WarnFilterEditor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    virtual bool GeneralCheck() const;
  protected:
    jfCharCheckBoxGroup* insert_panel;
};
/*****************************************************************************/
