/******************************************************************************
Name    :   sexpr_edit.h
Author  :   John Q Metro
Purpose :   Simple Expression editors
Created :   December 4, 2010
Updated :   June 13, 2012
******************************************************************************/
#ifndef SEXPR_EDIT_H_INCLUDED
#define SEXPR_EDIT_H_INCLUDED
#endif // SEXPR_EDIT_H_INCLUDED
//-------------------------------------------------------------------------------------
#ifndef SEXP_FILTERS_H_INCLUDED
  #include "../../../core/filters/base/sexp_filters.h"
#endif // SEXP_FILTERS_H_INCLUDED
//****************************************************************************
/* The simple expression editor has an edit box and one button, for checking
the validity of an expression

Color coding will be used to determine errors:
0: Green, okay
1: Black, unchecked
2: Red, in error
*/
class jfSimpleExprEdit : public wxPanel {
  public:
    jfSimpleExprEdit(wxWindow* parent, wxWindowID id, bool mline);
    // events
    void PressCheckFilter(wxCommandEvent& event);
    void TextChanged(wxCommandEvent& event);
    // checking method
    jfSimpleExpr* CheckFilter(wxString& outmessage);
    bool CheckExpr(const wxString& inexpr,wxString& outmessage) const;
    // setting data
    bool SetData(const wxString& inexpr,wxString& outmessage);
  protected:
    // internal helper
    void SetStatus(size_t instatus);
    // the internal controls
    wxTextCtrl* editcore;
    wxButton* fcheck_btn;
    // sizers (horizontal, buttons on the right)
    wxBoxSizer* topsizer;
    // error info
    size_t error_code;

    DECLARE_EVENT_TABLE()
};
//****************************************************************************
