/******************************************************************************
Name    :   sfilt_edit.h
Author  :   John Q Metro
Purpose :   Filter editors (wraaping the core). Simple expression & mo0re
Created :   December 5, 2010
Updated :   November 15, 2011
******************************************************************************/
#ifndef SFILT_EDIT_H_INCLUDED
#define SFILT_EDIT_H_INCLUDED
#endif // SFILT_EDIT_H_INCLUDED
//+++++++++++++++++++++++++++++++++++
#ifndef BFILT_EDIT_H_INCLUDED
  #include "bfilt_edit.h"
#endif // BFILT_EDIT_H_INCLUDED
#ifndef SEXPR_EDIT_H_INCLUDED
  #include "sexpr_edit.h"
#endif // SEXPR_EDIT_H_INCLUDED
//****************************************************************************
// core wrapper for jfFimpleExprEdit
class jfSimpleSFilterEditor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfSimpleSFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfSimpleExpFilterCore* infilt, wxWindowID id, const wxString& name);
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    // checking
    bool GeneralCheck() const;
  protected:
    // internal methods
    virtual jfSimpleExpFilterCore* MakeTypedFilter(jfSimpleExpr* inpval) = 0;
    // internal data
    jfSimpleExprEdit* insert_panel;
    const jfSimpleExpFilterCore* typed_fpointer;
};
//==========================================================================
/* a wrapper for jfSimpleExprEdit that is for an author filter */
class jfAuthorFilterEditor : public jfSimpleSFilterEditor {
  public:
    // the default constructor
    jfAuthorFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfAuthExprFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfAuthorFilterEditor"));
  protected:
    // internal methods
    virtual jfSimpleExpFilterCore* MakeTypedFilter(jfSimpleExpr* inpval);
};
//================================================================================
/* a wrapper for jfSimpleExprEdit that is for an character filter */
class jfCharFilterEditor : public jfSimpleSFilterEditor {
  public:
    // the default constructor
    jfCharFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfCharExprFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfCharFilterEditor"));
  protected:
    // internal methods
    virtual jfSimpleExpFilterCore* MakeTypedFilter(jfSimpleExpr* inpval);
};
//================================================================================
/* a wrapper for jfSimpleExprEdit that is for a category filter */
class jfCategoryFilterEditor : public jfSimpleSFilterEditor {
  public:
    // the default constructor
    jfCategoryFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfCategoryExprFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfCategoryFilterEditor"));
  protected:
    // internal methods
    virtual jfSimpleExpFilterCore* MakeTypedFilter(jfSimpleExpr* inpval);
};
//================================================================================
/* a wrapper for jfSimpleExprEdit that is for a language filter */
class jfLanguageFilterEditor : public jfSimpleSFilterEditor {
  public:
    // the default constructor
    jfLanguageFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfLanguageExprFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfLanguageFilterEditor"));
  protected:
    // internal methods
    virtual jfSimpleExpFilterCore* MakeTypedFilter(jfSimpleExpr* inpval);
};


//****************************************************************************
