/******************************************************************************
Name    :   drange_edit.cpp
Author  :   John Q Metro
Purpose :   Defines some classes for editing date range filters
Created :   December 8, 2011
Updated :   December 8, 2011
******************************************************************************/
#ifndef DRANGE_EDIT_H_INCLUDED
  #include "drange_edit.h"
#endif // DRANGE_EDIT_H_INCLUDED
//==============================================================

/******************************************************************************/
// the default constructor
jfUpdatedDateFilterEditor::jfUpdatedDateFilterEditor(wxWindow* parent, const jfUpdatedDateFilter* infilt,
    const jfFilterMap* infmap, wxWindowID id, const wxString& name):jfBaseFilterEditor(parent,infmap,infilt,id,name) {
  // starting...
  insert_panel = new jfDateRangePanel(this,-1);
  // finalizing things
  insert = new wxBoxSizer(wxVERTICAL);
  insert->Add(insert_panel,1,wxALL|wxEXPAND,2);
  insert_panel->LoadValue(dynamic_cast<const jfDateRangeFilter*>(filt_pointer));
  // calling the sizers
  ArrangeSizers();
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// implemented virtual methods
//---------------------------------------------------
void jfUpdatedDateFilterEditor::LoadFilter(const jfBaseFilter* infilter) {
  assert(infilter!=NULL);
  filt_pointer = infilter;
  insert_panel->LoadValue(dynamic_cast<const jfUpdatedDateFilter*>(filt_pointer));
  NameLoad();
}
//---------------------------------------------------
jfBaseFilter* jfUpdatedDateFilterEditor::GetFilter() {
  jfUpdatedDateFilter* result = new jfUpdatedDateFilter();
  insert_panel->StoreValue(result);
  namedesc_edit->ChangeObj(result);
  return result;
}
//---------------------------------------------------
bool jfUpdatedDateFilterEditor::GeneralCheck() const {
  bool rval = insert_panel->CheckOk();
  if (!rval) insert_panel->ShowErrorMsg();
  return rval;
}
//======================================================================
// the default constructor
jfPublishedDateFilterEditor::jfPublishedDateFilterEditor(wxWindow* parent, const jfPublishedDateFilter* infilt,
    const jfFilterMap* infmap, wxWindowID id, const wxString& name):jfBaseFilterEditor(parent,infmap,infilt,id,name) {
  // starting...
  insert_panel = new jfDateRangePanel(this,-1);
  // finalizing things
  insert = new wxBoxSizer(wxVERTICAL);
  insert->Add(insert_panel,1,wxALL|wxEXPAND,2);
  insert_panel->LoadValue(dynamic_cast<const jfDateRangeFilter*>(filt_pointer));
  // calling the sizers
  ArrangeSizers();
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// implemented virtual methods
//---------------------------------------------------
void jfPublishedDateFilterEditor::LoadFilter(const jfBaseFilter* infilter) {
  assert(infilter!=NULL);
  filt_pointer = infilter;
  insert_panel->LoadValue(dynamic_cast<const jfPublishedDateFilter*>(filt_pointer));
  NameLoad();
}
//---------------------------------------------------
jfBaseFilter* jfPublishedDateFilterEditor::GetFilter() {
  jfPublishedDateFilter* result = new jfPublishedDateFilter();
  insert_panel->StoreValue(result);
  namedesc_edit->ChangeObj(result);
  return result;
}
//---------------------------------------------------
bool jfPublishedDateFilterEditor::GeneralCheck() const {
  bool rval = insert_panel->CheckOk();
  if (!rval) insert_panel->ShowErrorMsg();
  return rval;
}

/******************************************************************************/
