/******************************************************************************
Name    :   drange_edit.h
Author  :   John Q Metro
Purpose :   Declares some classes for editing date range filters
Created :   December 8, 2011
Updated :   December 8, 2011
******************************************************************************/
#ifndef DRANGE_EDIT_H_INCLUDED
#define DRANGE_EDIT_H_INCLUDED
#endif // DRANGE_EDIT_H_INCLUDED
//==============================================================
#ifndef MFILT_EDIT1_H_INCLUDED
  #include "mfilt_edit1.h"
#endif // MFILT_EDIT1_H_INCLUDED
#ifndef BFILT_EDIT_H_INCLUDED
  #include "bfilt_edit.h"
#endif // BFILT_EDIT_H_INCLUDED
/******************************************************************************/
// filter editor wrap for jfDateRangePanel, updated Version
class jfUpdatedDateFilterEditor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfUpdatedDateFilterEditor(wxWindow* parent, const jfUpdatedDateFilter* infilt, const jfFilterMap* infmap,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfUpdatedDateFilterEditor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    virtual bool GeneralCheck() const;
  protected:
    jfDateRangePanel* insert_panel;
};
//============================================================
// filter editor wrap for jfDateRangePanel, Publishe Version
class jfPublishedDateFilterEditor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfPublishedDateFilterEditor(wxWindow* parent, const jfPublishedDateFilter* infilt, const jfFilterMap* infmap,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfPublishedDateFilterEditor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    virtual bool GeneralCheck() const;
  protected:
    jfDateRangePanel* insert_panel;
};
/******************************************************************************/
