/******************************************************************************
Name    :   filters_edit1.h
Author  :   John Q Metro
Purpose :   Editors for more filters : word count
Created :   December 6, 2010
Updated :   September 3, 2015
******************************************************************************/
#ifndef FILTERS_EDIT1_H_INCLUDED
#define FILTERS_EDIT1_H_INCLUDED
#endif // FILTERS_EDIT1_H_INCLUDED
//--------------------------------------------
#ifndef WIDGETS2_H_INCLUDED
  #include "../../misc/widgets2.h"
#endif // WIDGETS2_H_INCLUDED
#ifndef WIDGETS3_H_INCLUDED
  #include "../../misc/widgets3.h"
#endif // WIDGETS3_H_INCLUDED
#ifndef MOREFILTERS1_H_INCLUDED
  #include "../../../core/filters/extended/morefilters1.h"
#endif
#ifndef BFILT_EDIT_H_INCLUDED
  #include "../base/bfilt_edit.h"
#endif // BFILT_EDIT_H_INCLUDED

#include <wx/spinctrl.h>
//******************************************************************************/
// core of word count (and other unsigned min/max) filter editor
class jfMinMaxUPanel : public wxPanel {
  public:
    // the constructor
    jfMinMaxUPanel(wxWindow* parent, wxWindowID id = wxID_ANY,  jfMinMaxUFilter* inobj = NULL, const wxString& name = wxT("jfWordCountPanel"));
    // get
    bool Check() const;
    // set
    bool SetFromObj(const jfMinMaxUFilter* inval);
    bool LoadToObj(jfMinMaxUFilter* outval);
  protected:
    bool CheckCore(size_t& qmin, size_t& qmax) const;
    // gui elements
    wxStaticText *minl, *maxl;
    wxSpinCtrl *minbox, *maxbox;
    // sizers
    wxFlexGridSizer* msizer;
};
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// the actual word count filter editor, a wrapper for jfMinMaxUPanel
class jfWCFilterEditor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfWCFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfBaseFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfWCFilterEditor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    // checking
    bool GeneralCheck() const;
  private:
    jfMinMaxUPanel* insert_panel;
};
//========================================================================
// a generic tag filter editor
class jfTagFilterEditor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfTagFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfTagFilterCore* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfTagFilterEditor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    // extra methods
    virtual jfTagFilterCore* GetTagFilter() = 0;
    virtual jfTagFilterCore* MakeBlankTagFilter() = 0;
    // checking
    bool GeneralCheck() const;
  protected:
    void LoadBlank();
    jfTagCategorizer* insert_panel;
};
//============================================================================
class jfFFNTagFilterEditor : public jfTagFilterEditor {
  public:
    // the default constructor
    jfFFNTagFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfFFNTagFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfFFNTagFilterEditor"));
    // extra methods
    virtual jfTagFilterCore* GetTagFilter();
    virtual jfTagFilterCore* MakeBlankTagFilter();
};
//******************************************************************************/
