/******************************************************************************
Name    :   mfilt_edit1.h
Author  :   John Q Metro
Purpose :   Declares some base class for filter diting
Created :   November 11, 2011
Updated :   August 19, 2013
******************************************************************************/
#ifndef MFILT_EDIT1_H_INCLUDED
#define MFILT_EDIT1_H_INCLUDED
#endif // MFILT_EDIT1_H_INCLUDED
//==========================================================================
#ifndef EXPR_EDITOR_H_INCLUDED
  #include "../base/expr_editor.h"
#endif // EXPR_EDITOR_H_INCLUDED
#ifndef MOREFILTERS2_H_INCLUDED
  #include "../../../core/filters/extended/morefilters2.h"
#endif // MOREFILTERS2_H_INCLUDED
#ifndef BFILT_EDIT_H_INCLUDED
  #include "../base/bfilt_edit.h"
#endif // BFILT_EDIT_H_INCLUDED

#ifndef MOREFILTERS3_H_INCLUDED
  #include "../../../core/filters/extended/morefilters3.h"
#endif // MOREFILTERS3_H_INCLUDED

#ifndef FILTERS_EDIT1_H_INCLUDED
  #include "filters_edit1.h"
#endif // FILTERS_EDIT1_H_INCLUDED
#ifndef FIMFILTERS2_H_INCLUDED
  #include "../../../core/filters/fim/fimfilters2.h"
#endif // FIMFILTERS2_H_INCLUDED

#include <wx/datectrl.h>
//***************************************************************************/
// completed filter editor (single checkbox version)
class jfCFE_Core1 : public wxPanel {
  public:
    // constructor
    jfCFE_Core1(wxWindow* parent, wxWindowID id,const jfCompletedFilter* inmap);
    // setting and getting values
    bool StoreValue(jfCompletedFilter* saveto) const;
    bool LoadValue(const jfCompletedFilter* getfrom);
    jfCompletedFilter* GetValue() const;
  protected:
    // gui elements
    wxCheckBox* mainval1;
    wxBoxSizer* mainsizer;
};
//==========================================================================
class jfComplFiltEdit : public jfCFE_Core1 {
  public:
    jfComplFiltEdit(wxWindow* parent, wxWindowID id,const jfCompletedFilter* inmap);
};
//==========================================================================
// filter editor wrap for jfComplFiltEdit
class jfCompletedFilterEditor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfCompletedFilterEditor(wxWindow* parent,const jfBaseFilter* infilt, const jfFilterMap* infmap,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfCompletedFilterEditor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    virtual bool GeneralCheck() const;
  protected:
    jfComplFiltEdit* insert_panel;
};
//==========================================================================
class jfFFN_RatingEditPanel : public wxPanel {
  public:
    // constructor
    jfFFN_RatingEditPanel(wxWindow* parent, wxWindowID id,bool horizontal, const jfFFNRatingFilter* invalue);
    // setting and getting values
    bool StoreValue(jfFFNRatingFilter* saveto) const;
    bool LoadValue(const jfFFNRatingFilter* getfrom);
    jfFFNRatingFilter* GetValue() const;
  protected:
    // gui
    wxCheckBox *kch, *kpch, *tch, *mch;
    wxFlexGridSizer* fsizer;
    wxBoxSizer* bsizer;
    wxSizer* thesizer;
    bool ishoriz;
};
//==========================================================================
// filter editor wrap for jfFFN_RatingEditPanel
class jfFFN_RatingFilterEditor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfFFN_RatingFilterEditor(wxWindow* parent,const jfBaseFilter* infilt, const jfFilterMap* infmap,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfFFNFilterEditor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    virtual bool GeneralCheck() const;
  protected:
    jfFFN_RatingEditPanel* insert_panel;
};
//***************************************************************************
// date range editing panel
class jfDateRangePanel : public wxPanel {
  public:
    // constructor
    jfDateRangePanel(wxWindow* parent, wxWindowID id);
    // setting and getting values
    bool CheckOk() const;
    bool StoreValue(jfDateRangeFilter* saveto) const;
    bool LoadValue(const jfDateRangeFilter* getfrom);
    void MakeUndefined();
    void ShowErrorMsg() const;
    // events
    void EvUndefinedFrom(wxCommandEvent& inevent);
    void EvUndefinedTo(wxCommandEvent& inevent);
  protected:
    // private methods
    bool MakeBlock(bool from);
    // gui elements
    wxStaticText* from_label, *to_label;
    wxDatePickerCtrl* newdate;
    wxDatePickerCtrl* oldate;
    wxCheckBox* undefined_new;
    wxCheckBox* undefined_old;
    // sizers
    wxFlexGridSizer* topsizer;
    wxBoxSizer *fsizer, *tsizer;

    DECLARE_EVENT_TABLE()
};
//****************************************************************************
// A Fanfiction.Net Favs filter editor, a wrapper for jfMinMaxUPanel
class jfFFNFavsFilterEditor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfFFNFavsFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfBaseFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfWCFilterEditor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    // checking
    bool GeneralCheck() const;
  private:
    jfMinMaxUPanel* insert_panel;
};
//***************************************************************************/
