//***************************************************************************
// Name:        pairs_edit.h
// Author :     John Q Metro
// Purpose :    Relationship/Pairing filters editing, various panels.
// Created:     January 2, 2011
// Updated:     January 2, 2011
//***************************************************************************
#ifndef PAIRS_EDIT_H_INCLUDED
#define PAIRS_EDIT_H_INCLUDED
#endif // PAIRS_EDIT_H_INCLUDED
//--------------------------------------------------------------------------
#ifndef PAIRF_EDITOR_H_INCLUDED
  #include "pairf_editor.h"
#endif // PAIRF_EDITOR_H_INCLUDED
#ifndef BFILT_EDIT_H_INCLUDED
  #include "../base/bfilt_edit.h"
#endif // BFILT_EDIT_H_INCLUDED
//***************************************************************************
/* a wrapper for jfPairFilEditPanelSingle that is an editor for an single apir filter */
class jfPairFS_Editor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfPairFS_Editor(wxWindow* parent, const jfFilterMap* infmap,const jfPairFilterSingle* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfPairFS_Editor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    // checking
    virtual bool GeneralCheck() const;
  private:
    jfPairFilEditPanelSingle* insert_panel;
};
//=============================================================================
/* a wrapper for jfPairFilEditPanelList that is an editor for a name paired against a list */
class jfPairFL_Editor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfPairFL_Editor(wxWindow* parent, const jfFilterMap* infmap,const jfPairFilterList* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfPairFS_Editor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    // checking
    virtual bool GeneralCheck() const;
  private:
    jfPairFilEditPanelList* insert_panel;
};
//=============================================================================
/* a wrapper for jfPairFilEditPanelMulti that is an editor for an all combination list of names */
class jfPairFM_Editor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfPairFM_Editor(wxWindow* parent, const jfFilterMap* infmap,const jfPairFilterMultiple* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfPairFS_Editor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    // checking
    virtual bool GeneralCheck() const;
  private:
    jfPairFilEditPanelMulti* insert_panel;
};
//***************************************************************************
