/******************************************************************************
Name    :   fim1_filedit.h
Author  :   John Q Metro
Purpose :   Editors for fim filters : thumbs rating
Created :   July 5, 2012
Updated :September 3, 2015
******************************************************************************/
#ifndef FIM1_FILEDIT_H_INCLUDED
#define FIM1_FILEDIT_H_INCLUDED
#endif // FIM1_FILEDIT_H_INCLUDED
//---------------------------------------------------------------------------
#ifndef FIMFILTERS1_H_INCLUDED
  #include "../../../core/filters/fim/fimfilters1.h"
#endif // FIMFILTERS1_H_INCLUDED
#ifndef WIDGETS3_H_INCLUDED
  #include "../../misc/widgets3.h"
#endif // WIDGETS3_H_INCLUDED
#ifndef BFILT_EDIT_H_INCLUDED
  #include "../base/bfilt_edit.h"
#endif // BFILT_EDIT_H_INCLUDED
#ifndef FILTERS_EDIT1_H_INCLUDED
  #include "../extended/filters_edit1.h"
#endif // FILTERS_EDIT1_H_INCLUDED

#include <wx/spinctrl.h>
/*****************************************************************************/
// core of Thumbs Up / Thumbs Down filter editor
class jfFIMThumbsPanel : public wxPanel {
  public:
    // the constructor
    jfFIMThumbsPanel(wxWindow* parent, wxWindowID id = wxID_ANY,  jfFimThumbsFilter* inobj = NULL, const wxString& name = wxT("jfFIMThumbsPanel"));
    // get
    jfFimThumbsFilter* GetNewFilter() const;
    bool Check() const;
    // set
    bool SetFromObj(const jfFimThumbsFilter* inval);
  protected:
    // gui elements
    wxStaticText *minl, *maxl;
    wxSpinCtrl *minbox, *maxbox;
    // sizers
    wxFlexGridSizer* msizer;
};
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// the actual Thumbs Up / Thumbs Down filter editor, a wrapper for jfFIMThumbsPanel
class jfFimThumbsFilterEditor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfFimThumbsFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfBaseFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfFimThumbsFilterEditor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    // checking
    bool GeneralCheck() const;
  private:
    jfFIMThumbsPanel* insert_panel;
};
//============================================================================
class jfFimGenreFilterEditor : public jfTagFilterEditor {
  public:
    // the default constructor
    jfFimGenreFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfFIMGenreFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfFimGenreFilterEditor"));
    // extra methods
    virtual jfTagFilterCore* GetTagFilter();
    virtual jfTagFilterCore* MakeBlankTagFilter();
};
//============================================================================
class jfFimCharacterFilterEditor : public jfTagFilterEditor {
  public:
    // the default constructor
    jfFimCharacterFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfFIMCharacterFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfFimCharacterFilterEditor"));
    // extra methods
    virtual jfTagFilterCore* GetTagFilter();
    virtual jfTagFilterCore* MakeBlankTagFilter();
};
//============================================================================
class jfFIM_RatingEditPanel : public wxPanel {
  public:
    // constructor
    jfFIM_RatingEditPanel(wxWindow* parent, wxWindowID id,bool horizontal, const jfFimRatingFilter* invalue);
    // setting and getting values
    bool StoreValue(jfFimRatingFilter* saveto) const;
    bool LoadValue(const jfFimRatingFilter* getfrom);
    jfFimRatingFilter* GetValue() const;
  protected:
    // gui
    wxCheckBox *ech, *tch, *mch;
    wxBoxSizer* msizer;
    bool ishoriz;
};
//==========================================================================
// filter editor wrap for jfFIM_RatingEditPanel
class jfFIM_RatingFilterEditor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfFIM_RatingFilterEditor(wxWindow* parent,const jfBaseFilter* infilt, const jfFilterMap* infmap,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfFIM_RatingFilterEditor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    virtual bool GeneralCheck() const;
  protected:
    jfFIM_RatingEditPanel* insert_panel;
};
//====================================================================================
// filter editor for jfFimThumbPercentFilter
class jfFimThumbPercentFilterEditor : public jfBaseFilterEditor {
    // the default constructor
  public:
    jfFimThumbPercentFilterEditor(wxWindow* parent,const jfBaseFilter* infilt, const jfFilterMap* infmap,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfFIMThumbPercentFilterEditor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    virtual bool GeneralCheck() const;
  protected:
    jfLabeledUIntEdit* insert_panel;
};
/*****************************************************************************/
