/******************************************************************************
Name    :   fim2_filedit.cpp
Author  :   John Q Metro
Purpose :   more Editors for fim filters
Created :   July 12, 2015
Updated :   July 12, 2015
******************************************************************************/
#ifndef FIM2_FILEDIT_H_INCLUDED
  #include "fim2_filedit.h"
#endif // FIM2_FILEDIT_H_INCLUDED
//-------------------------------------------
#ifndef FIMFILTERS2_H_INCLUDED
  #include "../../../core/filters/fim/fimfilters2.h"
#endif // FIMFILTERS2_H_INCLUDED
/*****************************************************************************/
// the default constructor
jfFIMShortDesc_FilterEditor::jfFIMShortDesc_FilterEditor(wxWindow* parent, const jfFilterMap*
      infmap, const jfFIM_ShortDesc_ExprFilter* infilt, wxWindowID id, const wxString&
      name):jfSimpleSFilterEditor(parent,infmap,infilt,id,name) {
  // most things are handled by the parent constructor
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// creating a filter from a simple expression
jfSimpleExpFilterCore* jfFIMShortDesc_FilterEditor::MakeTypedFilter(jfSimpleExpr* inpval) {
  jfFIM_ShortDesc_ExprFilter* result = new jfFIM_ShortDesc_ExprFilter(inpval);
  return result;
}
//========================================================================================
// the default constructor
jfFIMDualDesc_FilterEditor::jfFIMDualDesc_FilterEditor(wxWindow* parent, const jfFilterMap*
      infmap, const jfFIM_DualDesc_ExprFilter* infilt, wxWindowID id, const wxString&
      name):jfSimpleSFilterEditor(parent,infmap,infilt,id,name) {
  // most things are handled by the parent constructor
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// creating a filter from a simple expression
jfSimpleExpFilterCore* jfFIMDualDesc_FilterEditor::MakeTypedFilter(jfSimpleExpr* inpval) {
  jfFIM_DualDesc_ExprFilter* result = new jfFIM_DualDesc_ExprFilter(inpval);
  return result;
}
//========================================================================================
jfFIMGroupSCFilterEditor::jfFIMGroupSCFilterEditor(wxWindow* parent, const jfFilterMap*
      infmap, const jfBaseFilter* infilt, wxWindowID id, const wxString&
      name):jfBaseFilterEditor(parent,infmap,infilt,id,name) {
  // most things are handled by the parent constructor
  // we create the insert.. the *actual* expression editor
  insert_panel = new jfMinMaxUPanel(this,-1,NULL);
  if (filt_pointer!=NULL) {
    insert_panel->SetFromObj(dynamic_cast<const jfFIMGroupSCFilter*>(filt_pointer));
  }
  // finalizing things
  insert = new wxBoxSizer(wxVERTICAL);
  insert->Add(insert_panel,0,wxALL|wxEXPAND,2);
  // calling the sizers
  ArrangeSizers();
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void jfFIMGroupSCFilterEditor::LoadFilter(const jfBaseFilter* infilter) {
  const wxString fname = wxT("jfFIMGroupSCFilterEditor::LoadFilter");
  assert(infilter!=NULL);
  // loading the data
  filt_pointer = infilter;
  insert_panel->SetFromObj(dynamic_cast<const jfFIMGroupSCFilter*>(filt_pointer));
  NameLoad();
}
//------------------------------------------------------------------------------
jfBaseFilter* jfFIMGroupSCFilterEditor::GetFilter() {
  jfFIMGroupSCFilter* toutput;
  // getting the output
  toutput = new jfFIMGroupSCFilter();
  insert_panel->LoadToObj(toutput);
  namedesc_edit->ChangeObj(toutput);
  // done
  return toutput;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// checks if the contents are ok, returns false if they are not
bool jfFIMGroupSCFilterEditor::GeneralCheck() const {
  return insert_panel->Check();
}
//*****************************************************************************
jfFIMGroupMCFilterEditor::jfFIMGroupMCFilterEditor(wxWindow* parent, const jfFilterMap*
      infmap, const jfBaseFilter* infilt, wxWindowID id, const wxString&
      name):jfBaseFilterEditor(parent,infmap,infilt,id,name) {
  // most things are handled by the parent constructor
  // we create the insert.. the *actual* expression editor
  insert_panel = new jfMinMaxUPanel(this,-1,NULL);
  if (filt_pointer!=NULL) {
    insert_panel->SetFromObj(dynamic_cast<const jfFIMGroupMCFilter*>(filt_pointer));
  }
  // finalizing things
  insert = new wxBoxSizer(wxVERTICAL);
  insert->Add(insert_panel,0,wxALL|wxEXPAND,2);
  // calling the sizers
  ArrangeSizers();
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void jfFIMGroupMCFilterEditor::LoadFilter(const jfBaseFilter* infilter) {
  const wxString fname = wxT("jfFIMGroupMCFilterEditor::LoadFilter");
  assert(infilter!=NULL);
  // loading the data
  filt_pointer = infilter;
  insert_panel->SetFromObj(dynamic_cast<const jfFIMGroupMCFilter*>(filt_pointer));
  NameLoad();
}
//------------------------------------------------------------------------------
jfBaseFilter* jfFIMGroupMCFilterEditor::GetFilter() {
  jfFIMGroupMCFilter* toutput;
  // getting the output
  toutput = new jfFIMGroupMCFilter();
  insert_panel->LoadToObj(toutput);
  namedesc_edit->ChangeObj(toutput);
  // done
  return toutput;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// checks if the contents are ok, returns false if they are not
bool jfFIMGroupMCFilterEditor::GeneralCheck() const {
  return insert_panel->Check();
}


/*****************************************************************************/
