/******************************************************************************
Name    :   fim2_filedit.h
Author  :   John Q Metro
Purpose :   more Editors for fim filters
Created :   July 12, 2015
Updated :   July 12, 2015
******************************************************************************/
#ifndef FIM2_FILEDIT_H_INCLUDED
#define FIM2_FILEDIT_H_INCLUDED
#endif // FIM2_FILEDIT_H_INCLUDED
//-------------------------------------------
#ifndef BFILT_EDIT_H_INCLUDED
  #include "../base/bfilt_edit.h"
#endif // BFILT_EDIT_H_INCLUDED
#ifndef FILTERS_EDIT1_H_INCLUDED
  #include "../extended/filters_edit1.h"
#endif // FILTERS_EDIT1_H_INCLUDED
#ifndef SFILT_EDIT_H_INCLUDED
  #include "../base/sfilt_edit.h"
#endif // SFILT_EDIT_H_INCLUDED
#ifndef FIMFILTERS2_H_INCLUDED
  #include "../../../core/filters/fim/fimfilters2.h"
#endif // FIMFILTERS2_H_INCLUDED
/*****************************************************************************/
/* a wrapper for jfSimpleExprEdit that is for the short FIM summary */
class jfFIMShortDesc_FilterEditor : public jfSimpleSFilterEditor {
  public:
    // the default constructor
    jfFIMShortDesc_FilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfFIM_ShortDesc_ExprFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfFIMShortDesc_FilterEditor"));
  protected:
    // internal methods
    virtual jfSimpleExpFilterCore* MakeTypedFilter(jfSimpleExpr* inpval);
};
//================================================================================
/* a wrapper for jfSimpleExprEdit that is for the short FIM summary OR the regualr description*/
class jfFIMDualDesc_FilterEditor : public jfSimpleSFilterEditor {
  public:
    // the default constructor
    jfFIMDualDesc_FilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfFIM_DualDesc_ExprFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfFIMDualDesc_FilterEditor"));
  protected:
    // internal methods
    virtual jfSimpleExpFilterCore* MakeTypedFilter(jfSimpleExpr* inpval);
};
//========================================================================
// A Fimfiction.net groups story count filter editor
class jfFIMGroupSCFilterEditor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfFIMGroupSCFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfBaseFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfWCFilterEditor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    // checking
    bool GeneralCheck() const;
  private:
    jfMinMaxUPanel* insert_panel;
};
//=======================================================================
// A Fimfiction.net groups story count filter editor
class jfFIMGroupMCFilterEditor : public jfBaseFilterEditor {
  public:
    // the default constructor
    jfFIMGroupMCFilterEditor(wxWindow* parent, const jfFilterMap* infmap, const jfBaseFilter* infilt,
        wxWindowID id = wxID_ANY, const wxString& name = wxT("jfWCFilterEditor"));
    // implemented virtual methods
    virtual void LoadFilter(const jfBaseFilter* infilter);
    virtual jfBaseFilter* GetFilter();
    // checking
    bool GeneralCheck() const;
  private:
    jfMinMaxUPanel* insert_panel;
};
/*****************************************************************************/
