/******************************************************************************
Name    :   interface_ids.cpp
Author  :   John Q Metro
Purpose :   window and widget identifiers and events
Created :   April 11, 2009
Updated :   July 23, 2015
******************************************************************************/
#ifndef INTERFACE_IDS_H_INCLUDED
  #include "interface_ids.h"
#endif // INTERFACE_IDS_H_INCLUDED
//*****************************************************************************

//***************************************************************************
DEFINE_EVENT_TYPE(jf_DOWNL_START_EVENT  )
DEFINE_EVENT_TYPE(jf_DOWNL_END_EVENT    )
DEFINE_EVENT_TYPE(jf_DOWNL_PSTART_EVENT )
DEFINE_EVENT_TYPE(jf_DOWNL_PPROC_EVENT  )
DEFINE_EVENT_TYPE(jf_DOWNL_PEND_EVENT   )
DEFINE_EVENT_TYPE(jf_DOWNL_PFAIL_EVENT  )
DEFINE_EVENT_TYPE(jf_DOWNL_PHALT_EVENT  )
DEFINE_EVENT_TYPE(jf_DOWNL_PCOUNT_EVENT )
DEFINE_EVENT_TYPE(jf_DOWNL_RESET_EVENT  )
DEFINE_EVENT_TYPE(jf_DOWNL_LABELS_EVENT )
//---------------------------------------------------------------------------
DEFINE_EVENT_TYPE(jf_DOWNL_CATSTART_EVENT )
DEFINE_EVENT_TYPE(jf_DOWNL_CATEND_EVENT   )
DEFINE_EVENT_TYPE(jf_DOWNL_CATCOUNT_EVENT )
DEFINE_EVENT_TYPE(jf_DOWNL_CATLABELS_EVENT)
// in progress panel, signalling that a button has been pressed
DEFINE_EVENT_TYPE(jf_BTNPAN_ALERT_EVENT )
//----------------------------------------------------------------------------
// some extra download ststus events
DEFINE_EVENT_TYPE(jf_DOWNL_PAUSE_EVENT)
DEFINE_EVENT_TYPE(jf_DOWNL_RESUME_EVENT)
DEFINE_EVENT_TYPE(jf_DOWNL_RETRY_EVENT)
DEFINE_EVENT_TYPE(jf_DOWNL_RPAUSE_EVENT)
//--------------------------------------------------------------------------
DEFINE_EVENT_TYPE(jf_DOWNL_PCHECK_EVENT)
//--------------------------------------------------------------
// another download event : running total of download amount
DEFINE_EVENT_TYPE(jf_DOWNL_DATATOTAL_EVENT)
//--------------------------------------------------------------------------
// some new events for updating
DEFINE_EVENT_TYPE(jf_UPDATE_INSERT_SIG)
DEFINE_EVENT_TYPE(jf_UPDATE_UPDATE_FIC)
DEFINE_EVENT_TYPE(jf_UPDATE_NEXTCAT_SIG)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
DEFINE_EVENT_TYPE(jf_RESORG_PAGEDONE_EVENT)
DEFINE_EVENT_TYPE(jf_RESLISTBOX_NEWCAT_EVENT)
DEFINE_EVENT_TYPE(jf_RESLISTBOX_BULKECAT_EVENT)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
DEFINE_EVENT_TYPE(jf_PP_SRCHDONE_EVENT)
DEFINE_EVENT_TYPE(jf_PP_SRCHFAIL_EVENT)
//------------------------------------------------------------------------
DEFINE_EVENT_TYPE(jf_MSG_SRCHDONE_EVENT)
//------------------------------------------------------------------------
DEFINE_EVENT_TYPE(jf_MSG_SRCHNDONE_EVENT)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
DEFINE_EVENT_TYPE(jf_HTML_RIGHTCLICK_EVENT)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
DEFINE_EVENT_TYPE(jf_RMENU_APPTXTFIL_EVENT)
DEFINE_EVENT_TYPE(jf_RMENU_EXLUDEURL_EVENT)
DEFINE_EVENT_TYPE(jf_RMENU_DOWNLFIC_EVENT)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
DEFINE_EVENT_TYPE(jf_TAGEDIT_OUTOF_EVENT)

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// events used to signal the Fanfiction.Net Category Downloader status display
DEFINE_EVENT_TYPE(jf_FFNCDS_PARTSTART_EVENT )
DEFINE_EVENT_TYPE(jf_FFNCDS_PARTEND_EVENT   )
DEFINE_EVENT_TYPE(jf_FFNCDS_DONE_EVENT      )
DEFINE_EVENT_TYPE(jf_FFNCDS_ABORT_EVENT     )

DEFINE_EVENT_TYPE(jf_FFNCDS_SIGNAL_DONE )
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
DEFINE_EVENT_TYPE(jf_FFN_CATPICKER_PICKED )

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
DEFINE_EVENT_TYPE(jf_PARSER_ITEMSDONE_EVENT)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// an event used by the upload old results panel to let the parent know things are done
DEFINE_EVENT_TYPE(jf_UPDATE_OLDUPLOADED_EVENT)
// used when uploading multiple empty cats from the old result to the progress bar
DEFINE_EVENT_TYPE(jf_OLDLOAD_BULKECATS_EVENT)
// this event is sent to the grandparent when all is done
DEFINE_EVENT_TYPE(jf_UPDATE_ALLDONE_EVENT)
DEFINE_EVENT_TYPE(jf_UPDATE_AUXTHREAD_DONE)
//----------------------------------------------------------------------------
// new event : when downloading a fic, this event signals that downloading is done, processing and writing is next
DEFINE_EVENT_TYPE(jf_FICDOWN_DOWNDONE)
// used in the fic downloader tool to send fic info to the dialog
DEFINE_EVENT_TYPE(jf_FICDOWN_FICINFO)
//------------------------------------------------------------------------------
// some more events for downloaded fic updates
// no files to update
DEFINE_EVENT_TYPE(jf_FICDOWNUP_NOFILES)
DEFINE_EVENT_TYPE(jf_FICDOWNUP_FICNUM )
// the result: update or not?
DEFINE_EVENT_TYPE(jf_FICDOWNUP_UPDATE)

//---------------------------------------------------------------------------------
// generic catgeory downloader events
DEFINE_EVENT_TYPE(jf_GENCAT_DONE_EVENT )
DEFINE_EVENT_TYPE(jf_GENCAT_ABORT_EVENT)
DEFINE_EVENT_TYPE(jf_GENCAT_SIGNAL_DONE)

//--------------------------------------------------------------------
// fic marking event
DEFINE_EVENT_TYPE(jf_FICMARK_EVENT)
// fic discard event
DEFINE_EVENT_TYPE(jf_FICDISCARD_EVENT)

//*****************************************************************************
