/******************************************************************************
Name    :   interface_ids.h
Author  :   John Q Metro
Purpose :   window and widget identifiers
Created :   March 26, 2009
Updated :   July 23, 2015
******************************************************************************/
// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#define INTERFACE_IDS_H_INCLUDED
//-------------------------------------------------------------------------------
#define jfID_EXPR_EDITOR_PICK             wxID_HIGHEST+1
#define jfID_EXPR_EDITOR_CHECK            wxID_HIGHEST+2
#define jfID_EXPR_EDITOR_EDIT             wxID_HIGHEST+3
#define jfID_NAME_EDITOR_EDIT             wxID_HIGHEST+4

#define jfID_CATEGORY_EDITOR_DELETE       wxID_HIGHEST+10
#define jfID_CATEGORY_EDITOR_PICKPATH     wxID_HIGHEST+11
#define jfID_CATEGORY_EDITOR_ABSCHK       wxID_HIGHEST+12
#define jfID_CATEGORIES_EDITOR_ADDCAT     wxID_HIGHEST+13
#define jfID_CATEGORIES_EDITOR_UDCHKBOX   wxID_HIGHEST+14

#define jfID_PROGPANEL                    wxID_HIGHEST+21
// jfDisplayResultOrganizer
#define jfID_DISPLAY_RESORG               wxID_HIGHEST+25

// sourcc category parser
#define jfID_SRCCAT_PARSER                wxID_HIGHEST+30

// button ids
#define jfID_PAUSERESUME                  wxID_HIGHEST+40
#define jfID_STOPBTN                      wxID_HIGHEST+41
#define jfID_STARTBTN                     wxID_HIGHEST+42
#define jfID_REFILTBTN                    wxID_HIGHEST+43
#define jfID_BUTTONPANEL                  wxID_HIGHEST+45
#define jfID_SSTOPBTN                     wxID_HIGHEST+46
#define jfID_STARTSTOPBTN                 wxID_HIGHEST+47

#define jfID_TOPNOTEBOOK                  wxID_HIGHEST+52
// filter editing stuff
#define jfID_BASE_RELOAD_BTN              wxID_HIGHEST+60
#define jfID_UFILTE_EOCHECK               wxID_HIGHEST+61

// main filter editing stuff
#define jfID_MFE_NEW_BTN                  wxID_HIGHEST+70
#define jfID_MFE_DEL_BTN                  wxID_HIGHEST+71
#define jfID_MFE_SAV_BTN                  wxID_HIGHEST+72
#define jfID_MFE_LPICKER                  wxID_HIGHEST+73

// global filter editing stuff
#define jfID_GFE_NEW_BTN                  wxID_HIGHEST+80
#define jfID_GFE_DEL_BTN                  wxID_HIGHEST+81
#define jfID_GFE_SAV_BTN                  wxID_HIGHEST+82
#define jfID_GFE_MPICKER                  wxID_HIGHEST+83

// menu ids
#define jfID_MENU_GLOBFILTER              wxID_HIGHEST+90
#define jfID_MENU_CLOSECURR               wxID_HIGHEST+91
#define jfID_MENU_NEWGOOGSEA              wxID_HIGHEST+92
#define jfID_MENU_HTMLOUT_ALL             wxID_HIGHEST+93
#define jfID_MENU_HTMLOUT_CUR             wxID_HIGHEST+94
#define jfID_MENU_GLOBSKEL                wxID_HIGHEST+95
#define jfID_MENU_SAVESEARCH              wxID_HIGHEST+96
#define jfID_MENU_SAVEASSEARCH            wxID_HIGHEST+97
#define jfID_MENU_OPENSEARCH              wxID_HIGHEST+98
#define jfID_MENU_DOWNFFNCATS             wxID_HIGHEST+99

#define jfID_MENU_NEWFFNSEA               wxID_HIGHEST+100
#define jfID_MENU_SAVEBUNDLE              wxID_HIGHEST+101
#define jfID_MENU_OPENBUNDLE              wxID_HIGHEST+102
#define jfID_MENU_NEWFIMSEA               wxID_HIGHEST+103
#define jfID_MENU_NEWAO3SEA               wxID_HIGHEST+104

#define jfID_MENU_DOWNFFNFIC              wxID_HIGHEST+110
#define jfID_MENU_DEFAULTDIRS             wxID_HIGHEST+111
#define jfID_MENU_UPDFFNFIC               wxID_HIGHEST+112
#define jfID_MENU_DOWNAO3CATS             wxID_HIGHEST+113
#define jfID_MENU_FFNGRPSEARCH            wxID_HIGHEST+114
#define jfID_MENU_DIRUPDATE               wxID_HIGHEST+115

// skeleton editor ids
#define jfID_SKELE_SAVEBTN                wxID_HIGHEST+200
#define jfID_SKELE_RESTBTN                wxID_HIGHEST+201
#define jfID_SKELE_GLLBSEL                wxID_HIGHEST+202

// right click menu ids
#define jfID_RMENU_ADDTXT                 wxID_HIGHEST+210
#define jfID_RMENU_EXLURL                 wxID_HIGHEST+211
#define jfID_RMENU_OPNURL									wxID_HIGHEST+212
#define jfID_RMENU_DOWNLFIC               wxID_HIGHEST+213
#define jfID_RMENU_FMREAD                 wxID_HIGHEST+214
#define jfID_RMENU_FMIGNORE               wxID_HIGHEST+215
#define jfID_RMENU_FMINTEREST             wxID_HIGHEST+216
#define jfID_RMENU_FMDOWNLOADED           wxID_HIGHEST+217
#define jfID_RMENU_FMUNMARK               wxID_HIGHEST+218

// tag editor ids
#define jfID_MOVEINTO_BTN                 wxID_HIGHEST+220
#define jfID_MOVEOUTO_BTN                 wxID_HIGHEST+221

// Fanfiction.Net Category downloader
#define jfID_FFNCDOWN_PAGE                wxID_HIGHEST+230
#define jfID_FFN_FICDOWNT                 wxID_HIGHEST+231
#define jfID_FFN_UPDDWNFIC                wxID_HIGHEST+232

#define jfID_AO3_CATDOWNL                 wxID_HIGHEST+235

// Fanfiction.Net Category Picker
#define jfID_FFNCPICK_SEC                 wxID_HIGHEST+240
#define jfID_FFNCPICK_CAT                 wxID_HIGHEST+241
#define jfID_FFNCPICK_CC1                 wxID_HIGHEST+242
/*
#define jfID_FFNCPICK_CC2                 wxID_HIGHEST+243
*/
#define jfID_FFNCPCK_DBTN                 wxID_HIGHEST+244

// fic downloader ids
#define jfID_FFNDOWN_DIRBTN               wxID_HIGHEST+250
#define jfID_FFNDOWN_COPBTN               wxID_HIGHEST+251

// misc ids
#define jfID_SEARCHNAME_EDIT              wxID_HIGHEST+260
#define jfID_DRANGEP_NEWDATE              wxID_HIGHEST+261
#define jfID_DRANGEP_OLDDATE              wxID_HIGHEST+262
#define jfID_AO3FANFIL_CHECK1             wxID_HIGHEST+263
#define jfID_AO3FANFIL_CHECK2             wxID_HIGHEST+264

// default directory dialog ids (reserve 20)
#define jfID_DEFDIRPICK_BTNBASE           wxID_HIGHEST+270
#define jfID_DEFDIRPICK_SAVBTN            wxID_HIGHEST+290

// directory update (reserve 2)
#define jfID_DIRUPDATE_BTNBASE            wxID_HIGHEST+300
#define jfID_DIRUPDATE_STARTBTN           wxID_HIGHEST+305

//******************************************************************************
BEGIN_DECLARE_EVENT_TYPES()

/* for events generated by downloading threads, GetInt returns the local thread
   id. Parent threads (parsers, and the like), return -1;
   GetExtraLong and GetString contain the data                      */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// new generation downloading events
DECLARE_EVENT_TYPE(jf_DOWNL_START_EVENT, -1)
DECLARE_EVENT_TYPE(jf_DOWNL_END_EVENT, -1)
DECLARE_EVENT_TYPE(jf_DOWNL_PSTART_EVENT, -1)
DECLARE_EVENT_TYPE(jf_DOWNL_PPROC_EVENT, -1)
DECLARE_EVENT_TYPE(jf_DOWNL_PEND_EVENT, -1)
DECLARE_EVENT_TYPE(jf_DOWNL_PHALT_EVENT, -1)
DECLARE_EVENT_TYPE(jf_DOWNL_PCOUNT_EVENT, -1)
DECLARE_EVENT_TYPE(jf_DOWNL_RESET_EVENT, -1)
DECLARE_EVENT_TYPE(jf_DOWNL_LABELS_EVENT, -1)
//----------------------------------------------------------------------------
// category downloading events
DECLARE_EVENT_TYPE(jf_DOWNL_CATSTART_EVENT, -1)
DECLARE_EVENT_TYPE(jf_DOWNL_CATEND_EVENT, -1)
DECLARE_EVENT_TYPE(jf_DOWNL_CATCOUNT_EVENT, -1)
DECLARE_EVENT_TYPE(jf_DOWNL_CATLABELS_EVENT, -1)
//----------------------------------------------------------------------------
// some extra download ststus events
DECLARE_EVENT_TYPE(jf_DOWNL_PAUSE_EVENT, -1)
DECLARE_EVENT_TYPE(jf_DOWNL_RESUME_EVENT, -1)
DECLARE_EVENT_TYPE(jf_DOWNL_RETRY_EVENT, -1)
DECLARE_EVENT_TYPE(jf_DOWNL_RPAUSE_EVENT, -1)
//--------------------------------------------------------------------------
// author download events
DECLARE_EVENT_TYPE(jf_DOWNL_PCHECK_EVENT, -1)
//----------------------------------------------------------------------------
// another download event : running total of download amount
DECLARE_EVENT_TYPE(jf_DOWNL_DATATOTAL_EVENT, -1)
//-----------------------------------------------------------------------
// some new events for updating
DECLARE_EVENT_TYPE(jf_UPDATE_INSERT_SIG, -1)
DECLARE_EVENT_TYPE(jf_UPDATE_UPDATE_FIC, -1)
DECLARE_EVENT_TYPE(jf_UPDATE_NEXTCAT_SIG, -1)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// in progress panel, signalling that a button has been pressed
DECLARE_EVENT_TYPE(jf_BTNPAN_ALERT_EVENT, -1)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// the following events are for the result organizer
//-----------------------------------------------------------------------------
// contains the results of a page after processing in jfResultUnitVector form
DECLARE_EVENT_TYPE(jf_RESORG_PAGEDONE_EVENT, -1)
//------------------------------------------------------------------------
/* an event to send to the html list box to indicate there is a new
current category */
DECLARE_EVENT_TYPE(jf_RESLISTBOX_NEWCAT_EVENT, -1)
// bulk empty categories message, for when we are uploading old results for updating
DECLARE_EVENT_TYPE(jf_RESLISTBOX_BULKECAT_EVENT, -1)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// signal from Progress Panel to jfMainSearchGroup that a search is done
DECLARE_EVENT_TYPE(jf_PP_SRCHDONE_EVENT, -1)
DECLARE_EVENT_TYPE(jf_PP_SRCHFAIL_EVENT, -1)
//------------------------------------------------------------------------
// signal from a jfMainSearchGroup to the top level that a search is done
DECLARE_EVENT_TYPE(jf_MSG_SRCHDONE_EVENT, -1)
//------------------------------------------------------------------------
// signal from a jfMainSearchGroup to the top level that a search is no longer done
DECLARE_EVENT_TYPE(jf_MSG_SRCHNDONE_EVENT, -1)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// events for popup menu
DECLARE_EVENT_TYPE(jf_HTML_RIGHTCLICK_EVENT, -1)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// events replayed by the popup menu
DECLARE_EVENT_TYPE(jf_RMENU_APPTXTFIL_EVENT, -1)
DECLARE_EVENT_TYPE(jf_RMENU_EXLUDEURL_EVENT, -1)
DECLARE_EVENT_TYPE(jf_RMENU_DOWNLFIC_EVENT, -1)
//-----------------------------------------------------------------------
// an event used for sending info on removing tags from categories in the tag editing
DECLARE_EVENT_TYPE(jf_TAGEDIT_OUTOF_EVENT, -1)
//----------------------------------------------------------------------
// events used to signal the Fanfiction.Net Category Downloader status display
DECLARE_EVENT_TYPE(jf_FFNCDS_PARTSTART_EVENT, -1)
DECLARE_EVENT_TYPE(jf_FFNCDS_PARTEND_EVENT,   -1)
DECLARE_EVENT_TYPE(jf_FFNCDS_DONE_EVENT,      -1)
DECLARE_EVENT_TYPE(jf_FFNCDS_ABORT_EVENT,     -1)

DECLARE_EVENT_TYPE(jf_FFNCDS_SIGNAL_DONE,     -1)
//-----------------------------------------------------------------------
// an event used to signal that a category has been picked
DECLARE_EVENT_TYPE(jf_FFN_CATPICKER_PICKED,     -1)
//----------------------------------------------------------------------
DECLARE_EVENT_TYPE(jf_PARSER_ITEMSDONE_EVENT, -1)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// an event used by the upload old results panel to let the parent know things are done
DECLARE_EVENT_TYPE(jf_UPDATE_OLDUPLOADED_EVENT, -1)
// used when uploading multiple empty cats from the old result to the progress bar
DECLARE_EVENT_TYPE(jf_OLDLOAD_BULKECATS_EVENT, -1)
// this event is sent to the grandparent when all is done
DECLARE_EVENT_TYPE(jf_UPDATE_ALLDONE_EVENT, -1)
// used when an aux thread (loading old results, combining) has to send a message to the dialog
DECLARE_EVENT_TYPE(jf_UPDATE_AUXTHREAD_DONE, -1)
//--------------------------------------------------------------------
// new event : when downloading a fic, this event signals that downloading is done, processing and writing is next
DECLARE_EVENT_TYPE(jf_FICDOWN_DOWNDONE, -1)
// used in the fic downloader tool to send fic info to the dialog
DECLARE_EVENT_TYPE(jf_FICDOWN_FICINFO, -1)
//-------------------------------------------------------------------------
// some more events for downloaded fic updates
// no files to update
DECLARE_EVENT_TYPE(jf_FICDOWNUP_NOFILES, -1)
DECLARE_EVENT_TYPE(jf_FICDOWNUP_FICNUM , -1)
// the result: update or not?
DECLARE_EVENT_TYPE(jf_FICDOWNUP_UPDATE, -1)

//---------------------------------------------------------------------------------
// generic catgeory downloader events
DECLARE_EVENT_TYPE(jf_GENCAT_DONE_EVENT  , -1)
DECLARE_EVENT_TYPE(jf_GENCAT_ABORT_EVENT , -1)
DECLARE_EVENT_TYPE(jf_GENCAT_SIGNAL_DONE , -1)

//--------------------------------------------------------------------
// fic marking event
DECLARE_EVENT_TYPE(jf_FICMARK_EVENT  , -1)
// fic discard event
DECLARE_EVENT_TYPE(jf_FICDISCARD_EVENT  , -1)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
END_DECLARE_EVENT_TYPES()
//*****************************************************************************
