/******************************************************************************
Name    :   charo_editor.h
Author  :   John Q Metro
Purpose :   Editor with a collection of checkboxes that have single-char i/o
Created :   September 8, 2012
Updated :   September 11, 2012
******************************************************************************/
#ifndef CHARO_EDITOR_H_INCLUDED
#define CHARO_EDITOR_H_INCLUDED
#endif // CHARO_EDITOR_H_INCLUDED
//---------------------------------------------
#include <vector>
#include <wx/checkbox.h>
#include <wx/panel.h>
#include <wx/sizer.h>
/*****************************************************************************/
class jfCharCheckBoxGroup : public wxPanel {
  public:
    // constructor
    jfCharCheckBoxGroup(wxWindow* parent, wxWindowID id, wxString inname, size_t icount,
        const wxChar* inlabels[], const wxString inchars, size_t incols,
        const wxString& name = wxT("CharCheckBoxGroup"));
    // i/o
    bool SetFromString(const wxString& inval);
    wxString GetStringValue() const;
    // special
    void CheckAll(bool doit = true);
  protected:
    void SetupSizers(size_t tcount, size_t colcount);
    // GUI data
    std::vector<wxCheckBox*> cboxes;
    size_t cbcount;
    wxFlexGridSizer* fsizer;
    wxStaticBoxSizer* msizer;
    wxSizer* qsizer;
    // non gui data
    wxString charvals;
    wxString mainlabel;
    size_t mode;
};
/*****************************************************************************/
