/***************************************************************
 * Name:      defaultdir_dilaog.h
 * Purpose:   Declares dialog for default directory editing
 * Author:    John Q Metro (johnqmetro@hotmail.com)
 * Created:   December 18, 2011
 * Updated:   March 3, 2012
 *
**************************************************************/
#ifndef DEFAULTDIR_DIALOG_H_INCLUDED
#define DEFAULTDIR_DIALOG_H_INCLUDED
#endif // DEFAULTDIR_DIALOG_H_INCLUDED
//---------------------------------------------
#ifndef INITEND_H_INCLUDED
  #include "../../initend.h"
#endif // INITEND_H_INCLUDED
//------------------------------
#include <wx/wxprec.h>
#ifdef __BORLANDC__
#pragma hdrstop
#endif
#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#ifndef WIDGETS3_H_INCLUDED
  #include "widgets3.h"
#endif // WIDGETS3_H_INCLUDED
//****************************************************************************
// display panel with directory editors
class jfDefaultDirDisplay : public wxPanel {
  public:
    // constructor
    jfDefaultDirDisplay(wxWindow* parent, const wxString& name = wxT("DefaultDirDisplay "));
    // load and save
    void LoadValues();
    void SaveValues() const;
    wxString GetValue(size_t tindex) const;
    bool SetValue(size_t tindex, wxString inval);
    int TestDirs() const;
    // events
    void DisplayDirpicker(wxCommandEvent& mevent);
  protected:
    // gui builder methods
    void MakeLabels();
    void MakeRest();
    bool InsertRow(size_t rowval);
    // GUI ELEMENTS
    wxStaticText* labels[globalsettings::GV_NUMVALS];
    wxStaticText* colons[globalsettings::GV_NUMVALS];
    wxTextCtrl*   displays[globalsettings::GV_NUMVALS];
    wxButton*     dirpickers[globalsettings::GV_NUMVALS];
    // other things
    wxFlexGridSizer* main_sizer;
	// the event handler declaration
    DECLARE_EVENT_TABLE()
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// dialog for the directory editor
class jfDefaultDirsDialog : public wxDialog {
  public:
    // constructor
    jfDefaultDirsDialog(wxWindow* parent, wxWindowID id,const wxString& name = wxT("DefaultDirsDialog"));
    // events
    void SaveButton(wxCommandEvent& mevent);
  protected:
    void ShowErrorMessage(int dindex);
    // GUI elements
    wxCheckBox* loggingon_cb;
    jfFilesizeHintWidget* shint;
    wxBoxSizer* topbar;
    jfDefaultDirDisplay* contents;
    wxButton* saveclose_btn;
    // top level sizer
    wxBoxSizer* main_sizer;
	// the event handler declaration
    DECLARE_EVENT_TABLE()

};
//****************************************************************************
