/***************************************************************
 * Name:      dirupdate_dialog.h
 * Purpose:   Declares dialog for updating directories
 * Author:    John Q Metro (johnqmetro@hotmail.com)
 * Created:   June 30, 2015
 * Updated:   July 5, 2015
 *
**************************************************************/
#ifndef DIRUPDATE_DIALOG_H_INCLUDED
#define DIRUPDATE_DIALOG_H_INCLUDED
#endif // DIRUPDATE_DIALOG_H_INCLUDED
//---------------------------------------------------
#ifndef PROGRESSPANEL_H_INCLUDED
  #include "../threads/progresspanel.h"
#endif // PROGRESSPANEL_H_INCLUDED
#ifndef DIRUPDATE_THREAD_H_INCLUDED
  #include "../../ficdown/threads/dirupdate_thread.h"
#endif // DIRUPDATE_THREAD_H_INCLUDED

#include <wx/panel.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/button.h>
#include <wx/sizer.h>
#include <wx/dialog.h>
#include <wx/sizer.h>
//**********************************************************************
// display panel with directory editors
class jfUpdateDirectoryPickPanel : public wxPanel {
  public:
    // constructor
    jfUpdateDirectoryPickPanel(wxWindow* parent, const wxString& name = wxT("UpdateDirectoryPickPanel"));
    // load and save
    wxString GetValue(bool source) const;
    bool SetValue(bool source, wxString inval);
    int TestDirs() const;
    // events
    void DisplayDirpicker(wxCommandEvent& mevent);
  protected:
    // gui builder methods
    void MakeWidgets();
    // GUI ELEMENTS
    wxStaticText* labels[2];
    wxTextCtrl*   displays[2];
    wxButton*     dirpickers[2];
    // other things
    wxFlexGridSizer* main_sizer;
	// the event handler declaration
    DECLARE_EVENT_TABLE()
};
//=====================================================================
class jfUpdateDirectory_Dialog : public wxDialog {
  public:
    // constructor
    jfUpdateDirectory_Dialog(wxWindow* parent, wxWindowID id, const wxString& title, wxString inname = wxT("UpdateDirectory_Dialog"));
    // event handlers from the panel
    void EvEndSignal(wxCommandEvent& mevent);
    void EvFailSignal(wxCommandEvent& mevent);
    // button handler events
    void EvStartButton(wxCommandEvent& mevent);
  protected:
    //private helpher methods
    void FinishSizers();
    bool GetDirectories(wxString& out_err);
    // GUI ELEMENTS
    jfUpdateDirectoryPickPanel* dpanel;
    jfProgressPanelSingle* mpanel;
    // sizer
    wxBoxSizer* mainsizer;
    // internal elements
    wxString sdir, tdir;
    jfDirUpdate_Thread* ud_thread;
  // event handler table
  DECLARE_EVENT_TABLE()
};
//**********************************************************************
