/******************************************************************************
Name    :   global_skel.h
Author  :   John Q Metro
Purpose :   A global skeleton editor
Created :   December 1, 2009
Updated :   September 5, 2011
******************************************************************************/
#ifndef SKELEDIT_H_INCLUDED
  #include "skeledit.h"
#endif

#ifndef SKELSTORE_H_INCLUDED
  #include "../../core/objs/skelstore.h"
#endif // SKELSTORE_H_INCLUDED
#ifndef SKELCOLL_H_INCLUDED
  #include "../../core/structs/skelcoll.h"
#endif // SKELCOLL_H_INCLUDED
#ifndef INTERFACE_IDS_H_INCLUDED
  #include "../interface_ids.h"
#endif // INTERFACE_IDS_H_INCLUDED
//------------------------------------------------------------------
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#ifndef GLOBAL_SKEL_H_INCLUDED
#define GLOBAL_SKEL_H_INCLUDED
#endif // GLOBAL_SKEL_H_INCLUDED
/*****************************************************************************/
class jfGlobalSkeletonEdit : public wxPanel {
  public:
    // constructor
    jfGlobalSkeletonEdit(wxWindow* parent, wxWindowID id,jfSkelCollection* icoll_link);
    // evaluation
    void ListSelect(wxCommandEvent& event);
  protected:
    // helper methods
    bool ToSingle(jfSkeletonSingle* inval);
    bool ToMultiple(jfSkeletonMultiple* inval);
    bool ToFicPart(jfSkeletonFicPart* inval);
    // more helper methods
    bool ChangePanel(jfSkelEditCore* inskel);
    // gui elements
    wxListBox* selector;
    jfSkelEditSingle* single;
    jfSkelEditMultiple* multiple;
    jfSkelEditFicPart* ficpart;
    // local values
    jfs_Skeltype stype;
    jfSkelCollection* coll_link;
    size_t i_index;
    // sizers
    wxBoxSizer* topsizer;

    DECLARE_EVENT_TABLE()
};

/*****************************************************************************/
