/*****************************************************************************
Name:        menu.h
Author :     John Q Metro
Purpose :    Declares custom popup menu classes
Created:     January 5, 2010
Updated:     July 1, 2015
******************************************************************************/
#ifndef MENU_H_INCLUDED
#define MENU_H_INCLUDED
#endif // MENU_H_INCLUDED
//------------------
#include <wx/menu.h>
//---------------------
#ifndef SEARCHCORE_H_INCLUDED
  #include "../../core/objs/searchcore.h"
#endif // SEARCHCORE_H_INCLUDED
#ifndef FICMARKING_H_INCLUDED
  #include "../../core/structs/ficmarking.h"
#endif // FICMARKING_H_INCLUDED
/*****************************************************************************/
// a forward declaration
class jfMainSearchGroup;
//--------------------------------------------------------
class jfPopupMenu : public wxMenu {
  public:
    // constructor
    jfPopupMenu(wxWindow* destination);
    // setting data
    void SetIndexes(wxString inurl, size_t in_itemidx, size_t in_collidx = 0);
    void SetMoreIndexes(jfHtmlResultCollection* inrc_pointer, size_t inres_ptr, size_t inres_index);
  protected:
    // menu handlers
		void OnLoadURL(wxCommandEvent& event);
    void OnAppendToExpressionFilter(wxCommandEvent& event);
    // internal data
    size_t coll_index, item_index;
		wxString indexurl;
		wxMenuItem* miDisplayUrl;
		wxMenuItem* miAppendText;
    wxWindow* dtarget;
    // some extra stuff for fanfic marking
    jfHtmlResultCollection* rc_pointer;
    size_t res_ptr, res_index;

};
//-----------------------------------------------------------------
class jfGooxPopupMenu : public jfPopupMenu {
  public:
    jfGooxPopupMenu(wxWindow* destination);
  protected:
    // menu handlers
    void OnExcludeUrl(wxCommandEvent& event);
    // internal data
    wxMenuItem* miExcludeUrl;
};
//-------------------------------------------------------------------
class jfFFNPopupMenu : public jfPopupMenu {
  public:
    jfFFNPopupMenu(wxWindow* destination);
  protected:
    // menu handlers
    void OnDownloadFic(wxCommandEvent& event);
    void onMarkAsRead(wxCommandEvent& event);
    void onMarkInterest(wxCommandEvent& event);
    void onMarkIgnore(wxCommandEvent& event);
    void onMarkAsDownloaded(wxCommandEvent& event);
    void onUnmark(wxCommandEvent& event);
    // core mark handler
    void CoreMark(jf_FicMark inmark);
    // internal data
    wxMenuItem* miDownloadFic;
    wxMenuItem* miMarkAsRead;
    wxMenuItem* miMarkIgnore;
    wxMenuItem* miMarkAsDownloaded;
    wxMenuItem* miMarkInterest;
    wxMenuItem* miUnmark;
};
//-----------------------------------------------------------------
class jfFIMGPopupMenu : public jfPopupMenu {
  public:
    jfFIMGPopupMenu(wxWindow* destination);
  protected:
    // menu handlers
    void onMarkAsDiscard(wxCommandEvent& event);
    void onUnmark(wxCommandEvent& event);
    // core mark handler
    void CoreMark(bool mark_discard);
    // internal data
    wxMenuItem* miMarkIgnore;
    wxMenuItem* miUnmark;
};
/*****************************************************************************/
