/******************************************************************************
Name    :   widgets2.h
Author  :   John Q Metro
Purpose :   Some more miscuser interface stuff
Created :   November 24, 2009
Updated :   January 3, 2014
******************************************************************************/
#ifndef WIDGETS2_H_INCLUDED
#define WIDGETS2_H_INCLUDED
#endif // WIDGETS2_H_INCLUDED
#ifndef JFMISCTYPES1
#include "../../core/objs/misc_types1.h"
#endif
//--------------------------------------------------------------------------
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif
/*****************************************************************************/
// a panel containing two vertically stacked wxTextCtrl and labels
class jfTwoTexts : public wxPanel {
  public:
    // the constructor
    jfTwoTexts(wxWindow* parent,wxString label1, wxString label2, size_t prp,
        bool multiline, wxWindowID id = wxID_ANY,const wxString& name = wxT("jfTwoTexts"));
    // setting strings
    void Set1(wxString inval);
    void Set2(wxString inval);
    void SetBoth(wxString inval1, wxString inval2);
    // getting strings
    wxString Get1() const;
    wxString Get2() const;
    void GetBoth(wxString& out1, wxString& out2) const;
  protected:
    // gui elements
    wxStaticText* slabel1;
    wxTextCtrl*   edit1;
    wxStaticText* slabel2;
    wxTextCtrl*   edit2;
    // sizers
    wxBoxSizer*   topsizer;
    size_t        prop;
};
//===========================================================================
// an editor for jfTagListing. we do a sub-editor first
class jfTagCategoryEdit : public wxPanel {
	public:
		// the constructor
		jfTagCategoryEdit(wxWindow* parent, wxWindowID id,jfTagListing* inlist, jfTAG_STATUS wstatus, const wxString& name = wxT("jfTagCategoryEdit"));
    // setting from source...
    bool SetFromSource(jfTagListing* inlist);
		// some functions
		void MoveIntoEnable(bool doenable);
    bool MoveInto(wxArrayString* list_of_tags);
    // event handlers
    void OnMoveInto(wxCommandEvent& event);
    void OnMoveOutof(wxCommandEvent& event);
    void OnSelected(wxCommandEvent& event);
    // graphics re-arranging
    bool ToSmallSize(bool doit);
	protected:
    // internal methods
    void LoadTags();
		// internal data
		jfTagListing *xlink;
		jfTAG_STATUS tag_type;
		// gui elements
		wxStaticText* main_label;
		wxListBox* tag_display;
		wxButton* move_into;
		wxButton* move_outof;
		bool ssize;
		// sizers
		wxBoxSizer* btn_sizer;
		wxBoxSizer* lbox_sizer;
		wxBoxSizer* top_sizer;

    DECLARE_EVENT_TABLE()

};
//--------------------------------------------------------------------
class jfTagCategorizer : public wxPanel {
  public:
    // the constructor
    jfTagCategorizer(wxWindow* parent, wxWindowID id, bool triple, jfTagListing* inlist, const wxString& name = wxT("jfTagCategorizer"));
    // setting from source...
    bool SetFromSource(jfTagListing* inlist);
    const jfTagListing* GetList() const;
    // events
    void OnMoveInto(wxCommandEvent& event);
    void OnMoveOutOf(wxCommandEvent& event);
    void OnSelected(wxCommandEvent& event);
    void HandleResize(wxSizeEvent& qevent);
    // graphics re-arranging
    bool ToSmallSize(bool doit);
  protected:
    // internal methods
    void LoadTags();
    void Mieall(bool enx=false);
    // internal data
    bool triple_mode;
    jfTagListing* xlist;
    // gui elements
    wxStaticText* main_label;
    jfTagCategoryEdit* sub_editors[3];
    wxListBox* main_tagbox;
    // sizers
    wxBoxSizer* subedit_sizer;
    wxBoxSizer* lbox_sizer;
    wxBoxSizer* top_sizer;

    DECLARE_EVENT_TABLE()
};


/*****************************************************************************/
