/******************************************************************************
Name    :   widgets3.h
Author  :   John Q Metro
Purpose :   Some misc user interface stuff
Created :   December 5, 2010
Updated :   September 3, 2015
******************************************************************************/
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <wx/stdpaths.h>
#include <wx/filepicker.h>
#include <wx/spinctrl.h>

//--------------------------------
#ifndef WIDGETS3_H_INCLUDED
#define WIDGETS3_H_INCLUDED
#endif // WIDGETS3_H_INCLUDED
//****************************************************************************
/*
// version of wxTextCtrl that takes Unsigned Integers only
class jfIntEdit : public wxTextCtrl {
  public:
    // constructor
    jfIntEdit(wxWindow* parent, wxWindowID id, bool issigned, long value, const wxString& name = wxT("jfIntEdit"));
    // value setting and getting
    bool GetSigned() const;
    bool GetLValue(long& ovalue) const;
    bool SetLValue(const long& inval);
  protected:
    bool svalue;
};
*/
//---------------------------------------------------------------------------
// grouping a wxTextCtrl and it's associated wxStaticTextLabel
class jfLabeledEditCore : public wxPanel {
  public:
    // constructor
    jfLabeledEditCore(wxWindow* parent, wxWindowID id, wxString label, size_t spacsize,int orient,const wxString& name);
    // setting data
    void SetLabel(wxString inval);
    // getting data
    wxString GetLabel() const;
  protected:
    // helper methods
    void SetUpWidgets(size_t ssize);
    // internal elements
    wxControl* the_editor;
    wxStaticText* the_label;
    wxString labeltext;
    wxBoxSizer* mksizer;
    int orientval;
};
//----------------------------------------------------------------------------
// grouping a wxTextCtrl and it's associated wxStaticTextLabel
class jfLabeledEdit : public jfLabeledEditCore {
  public:
    // constructor
    jfLabeledEdit(wxWindow* parent, wxWindowID id, wxString label, wxString data, size_t spacsize,int orient, const wxString& name = wxT("Labeled Edit"));
    // setting data
    void SetValue(wxString inval);
    void SetBoth(wxString in_label, wxString in_value);
    void SetFiletag(wxString inval);
    // getting data
    wxString GetValue() const;
  protected:
    wxTextCtrl* text_editor;
};
//--------------------------------------------------------------------------
// just like jfLabeledEdit, except we use the integer only wxSpinCtrl instead of wxTextCtrl
class jfLabeledUIntEdit : public jfLabeledEditCore {
  public:
    // constructor
    jfLabeledUIntEdit(wxWindow* parent,wxString label, size_t maxv, size_t data, size_t spacsize,  wxWindowID id = -1, int orient = wxHORIZONTAL, const wxString& name = wxT("Labeled Integer Edit"));
    // setting data
    virtual bool SetMaximum(const size_t& maxval);
    bool SetValue(size_t inval);
    virtual bool SetValMax(size_t inval);
    bool SetBoth(wxString in_label, size_t in_value);
    // getting data
    size_t GetValue() const;
  protected:
    // GUI parts
    wxSpinCtrl* spin_editor;
};

// specialization of jfLabeledUintEdit, because filesize hints are all over the place

class jfFilesizeHintWidget : public jfLabeledUIntEdit {
  public:
    // constructor
    jfFilesizeHintWidget(wxWindow* parent, wxWindowID id = -1);
    // setting data
    virtual bool SetMaximum(const size_t& maxval);
    virtual bool SetValMax(size_t inval);

};

//--------------------------------------------------------------------------
// a directory picker... wrapping a dialog launching button with a text display
class jfDirPicker : public wxPanel {
  public:
    // constructor
    jfDirPicker(wxWindow* parent, wxWindowID id, bool vertical, wxString indir = wxStandardPaths::Get().GetDocumentsDir(), const wxString& name = wxT("jfDirPicker"));
    // path i/o
    wxString GetPath() const;
    bool SetPath(wxString inval);
    // other stuff
    void ChangeLabel(wxString inlabel);
    // event handler
    void HandleNewDirectory(wxFileDirPickerEvent& inevent);
  protected:
    // helper methods
    bool ArrangeControls(bool vertical);
    // gui elements
    wxDirPickerCtrl* dirpicker;
    wxStaticText* dirlabel;
    wxStaticText* dirdisplay;
    wxBoxSizer* mainsizer;
    wxBoxSizer* subsizer;
    // data
    wxString thedirectory;
    // event handling
    DECLARE_EVENT_TABLE()
};
//****************************************************************************
