/*****************************************************************************
Name:        display_index.h
Author :     John Q Metro
Purpose :    At the the result display level, we have to to translate indexes in
             result display lists to source category index and offset.
Created:     April 23, 2011
Updated:     September 21, 2014
******************************************************************************/
#ifndef DISPLAY_INDEX_H_INCLUDED
#define DISPLAY_INDEX_H_INCLUDED
#endif // DISPLAY_INDEX_H_INCLUDED
//-----------------------------------------
#ifndef ORGANIZER_H_INCLUDED
  #include "organizer.h"
#endif // ORGANIZER_H_INCLUDED
#ifndef JF_FFNSEARCH
  #include "../../fanficnet/data/ffn_search.h"
#endif
#ifndef FICMARKING_H_INCLUDED
  #include "../../core/structs/ficmarking.h"
#endif // FICMARKING_H_INCLUDED
//------------------------------------------
#include <vector>
//*****************************************************************************
enum header_enum {he_ONECATEGORY,he_NOHEADER,he_NONEMPTY,he_ALWAYS};
//=============================================================================
class jfCatPVector : public std::vector<jfIndexPack*> {};
//=============================================================================
class jfDisplayIndexGroup : public wxObject {
  public:
    // constructor
    jfDisplayIndexGroup(bool douse_default, size_t in_num_rcats, header_enum in_hvalue);
    // public change methods
    bool AppendResults(jfResultUnitVector* newresult, size_t in_stotal);
    wxString GetHTML(size_t rcat_index, size_t nindex) const;
    void SetFicMarkHTML(size_t rcat_index, size_t nindex, jf_FicMark fmval);
    wxString GetUrl(size_t rcat_index, size_t nindex) const;
    void ItemsProcessed(size_t in_stotal);
    // public info methods
    size_t GetNewcount(size_t rindex) const;
    wxInt32 GetCatIndex() const;
    size_t GetCatcount() const;
    void ReverseLookup(size_t inres_index, size_t inlist_index, size_t& out_srccoll, wxInt32& out_srcindex) const;
    // clearing out stuff
    void ClearContents();
  protected:
    // special methods
    bool AppendPageResults(jfResultUnitVector* newresult, size_t in_stotal);
    bool AppendCatCore(jfCategoryResultIndexes* inval);
    bool AddPointers(size_t rloop, jfIndexPack* cpointer);
    // the categories
    std::vector<jfIndexPack*> categories;
    wxInt32 cindex;
    // the category pointers
    jfCatPVector* pointers[33];
    bool use_default;
    size_t num_rcats;
    // other data
    size_t newresc[33];
    mutable wxMutex mlock;
    header_enum hvalue;
};
//==========================================================================
class jfDisplayIndex_Basic : public jfDisplayIndexGroup {
  public:
    // constructor
    jfDisplayIndex_Basic(bool douse_default, size_t in_num_rcats, header_enum in_hvalue);
    // main methods
    bool AppendCategory(wxString catname, wxString cathtml);
    // destructor
    ~jfDisplayIndex_Basic();
  protected:
};
//*****************************************************************************
