/*****************************************************************************
Name:        ffn_index.h
Author :     John Q Metro
Purpose :    A Fanfiction.Net customized version of jfDisplayIndexGroup. This
             add update capability, which complicates things a great deal.
Created:     April 24, 2011
Updated:     November 30, 2013
******************************************************************************/
#ifndef FFN_INDEX_H_INCLUDED
#define FFN_INDEX_H_INCLUDED
#endif // FFN_INDEX_H_INCLUDED
//--------------------------------------------------
#ifndef DISPLAY_INDEX_H_INCLUDED
  #include "display_index.h"
#endif // DISPLAY_INDEX_H_INCLUDED
//*****************************************************************************
class jfDisplayIndex_FFN : public jfDisplayIndexGroup {
  public:
    // constructor
    jfDisplayIndex_FFN(bool douse_default, size_t in_num_rcats);
    // main methods
    bool AppendCategory(const jfFFNSCategory* incat, wxString incathb);
    bool AppendEmptCategories(jfBulk_EmptyCatInfo* inbcat);
    bool InsertCategory(const jfFFNSCategory* incat, wxString incathb);
    bool NextUpdateCat(const jfFFNSCategory* incat);
    bool InsertResults(jfResultUnitVector* newresult, size_t in_stotal);
    bool UpdateFic(jfResultUnit* inval);
    // extra methods
    size_t SetInsertMode(bool inval);
    // destructor
    ~jfDisplayIndex_FFN();
  protected:
    // helper methods
    bool CategorySame(size_t tindex, const jfFFNSCategory* incat);
    jfCatFFNResultIndexes* TypCpointer(wxInt32 xindex);
    // special methods
    bool InsertPageResults(jfResultUnitVector* newresult, size_t in_stotal);
    bool InsertCatCore(jfCatFFNResultIndexes* inval);
    // data
    bool insert_mode;
    wxInt32 uindex;
};
//*****************************************************************************
