/******************************************************************************
Name    :   extrapanels.cpp
Author  :   John Q Metro
Purpose :   Some additional Progress Panels
Created :   January 8, 2014
Updated :   January 11, 2014
******************************************************************************/
#ifndef EXTRAPANELS_H_INCLUDED
  #include "extrapanels.h"
#endif // EXTRAPANELS_H_INCLUDED
//-----------------------------------------------
#ifndef INTERFACE_IDS_H_INCLUDED
  #include "../interface_ids.h"
#endif // INTERFACE_IDS_H_INCLUDED
/*****************************************************************************/
jfProgressPanelFFNStyle::jfProgressPanelFFNStyle(wxWindow* parent, jf_MPP_Config in_layout,
        wxString motif_name):jfProgressPanelMultiBase(parent,in_layout,motif_name) {
  // custom for this panel
  sstop = false;
  sstop_btn = new wxButton(this,jfID_SSTOPBTN,wxT("Stop After"));
  sstop_btn->Enable(false);
  button_sizer->Add(sstop_btn,0,wxALL,3);
  // finally
  Layout();
}
//+++++++++++++++++++++++++++++++++++++++++++++++++
// some special external methods
bool jfProgressPanelFFNStyle::Reset() {
  cat_display->SetToZero();
  catindex = 0;
  sstop = false;
  sstop_btn->Enable(false);
  return BaseReset();
}
//+++++++++++++++++++++++++++++++++++++++++++++++++
// resizer methods
//-------------------------
bool jfProgressPanelFFNStyle::ReduceSize() {
    // varibales
  wxSize ssize;
  const size_t bsize = 10;
  const size_t fpsize = 8;
  const size_t bheight = 24;
  // changing the button height
  ChangeButtonHights(bheight,sstop_btn);
  page_display->ChangeSizes(bsize,fpsize);
  cat_display->ChangeSizes(bsize,fpsize);
  return true;
}
//-------------------------
bool jfProgressPanelFFNStyle::UnReduceSize() {
  ChangeButtonHights(dbheight,sstop_btn);
  page_display->RevertSizes();
  cat_display->RevertSizes();
  return true;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++
// event handler for the extra button!
void jfProgressPanelFFNStyle::SpecialStopBtnHandler(wxCommandEvent& event) {
  thepauser->SpecialStop();
  sstop = true;
  sstop_btn->Enable(false);
}
//+++++++++++++++++++++++++++++++++++++++++++++++++
// internal helper methods
//-------------------------
void jfProgressPanelFFNStyle::PostFinished() {
  sstop_btn->Enable(false);
  wxCommandEvent outevent(jf_PP_SRCHDONE_EVENT,GetId());
  wxPostEvent(GetParent(),outevent);
}
//-------------------------
void jfProgressPanelFFNStyle::PostFaliure(bool halted) {
  sstop_btn->Enable(false);
  if (halted && sstop) {
    wxCommandEvent outevent1(jf_PP_SRCHDONE_EVENT,GetId());
    outevent1.SetInt(halted);
    wxPostEvent(GetParent(),outevent1);
  }
  else {
    wxCommandEvent outevent2(jf_PP_SRCHFAIL_EVENT,GetId());
    outevent2.SetInt(halted);
    wxPostEvent(GetParent(),outevent2);
  }
}
//-------------------------
void jfProgressPanelFFNStyle::PostStopping() {
  sstop_btn->Enable(false);
}
//-------------------------
void jfProgressPanelFFNStyle::PostStarted() {
  sstop_btn->Enable(true);
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++
BEGIN_EVENT_TABLE(jfProgressPanelFFNStyle,jfProgressPanelMultiBase)
  EVT_BUTTON (jfID_SSTOPBTN, jfProgressPanelFFNStyle::SpecialStopBtnHandler )
END_EVENT_TABLE()
/*****************************************************************************/
