/******************************************************************************
Name    :   multipanel.h
Author  :   John Q Metro
Purpose :   The new progress panel, mutli-source-categories
Created :   December 17, 2013
Updated :   January 8, 2014
******************************************************************************/
#ifndef MULTIPANEL_H_INCLUDED
#define MULTIPANEL_H_INCLUDED
#endif // MULTIPANEL_H_INCLUDED
//-----------------------------
#ifndef PROGRESSPANEL_H_INCLUDED
  #include "progresspanel.h"
#endif // PROGRESSPANEL_H_INCLUDED
/*****************************************************************************/
// enum for multipanel configuration
enum jf_MPP_Config {jfmpp_Stacked, jfmpp_Sideways, jfmpp_Inserted};
//======================================================================

class jfProgressPanelMultiBase : public jfProgressPanelBase {
  public:
    // constructor
    jfProgressPanelMultiBase(wxWindow* parent, jf_MPP_Config in_layout, wxString motif_name);
    // some special external methods
    virtual bool Reset() = 0;
    jf_MPP_Config GetLayout() const;
    // handlers for thread events
    virtual void HandleDone(jfThreadEvent& tevent);
    // handlers for category thread events
    void HandleNewCategory(jfThreadEvent& tevent);
    void HandleCategoryEnd(jfThreadEvent& tevent);
    void HandleCategoryCount(jfThreadEvent& tevent);
    void HandleCategoryLabels(jfThreadEvent& tevent);
    // resizer methods
    virtual bool ReduceSize() = 0;
    virtual bool UnReduceSize() = 0;
  protected:
    // internal helper methods
    virtual void SetupSizers();
    virtual void PostFinished() = 0;
    virtual void PostFaliure(bool halted) = 0;
    virtual void PostStopping() = 0;
    virtual void PostStarted() = 0;
    // resizer methods
    bool ReduceSizeInt();
    bool UnReduceSizeInt();
    // GUI Elements
    jfLabeledGauge* cat_display;
    // sizer
    jf_MPP_Config mpp_layout;
    wxStaticBoxSizer* topsizer;
    wxBoxSizer* button_sizer;
    wxBoxSizer* q_sizer;
    // internal values
    size_t catindex;
    // declare event table
    DECLARE_EVENT_TABLE()
};
//======================================================================
class jfProgressPanelMulti : public jfProgressPanelMultiBase {
  public:
    // constructor
    jfProgressPanelMulti(wxWindow* parent, jf_MPP_Config in_layout, wxString motif_name);
    // some special external methods
    virtual bool Reset();
    // resizer methods
    virtual bool ReduceSize();
    virtual bool UnReduceSize();
  protected:
    // internal helper methods
    virtual void PostFinished();
    virtual void PostFaliure(bool halted);
    virtual void PostStopping();
    virtual void PostStarted();
};
/*****************************************************************************/
