/******************************************************************************
Name    :   ppanel_parts.h
Author  :   John Q Metro
Purpose :   Progress Panel parts and subparts
Created :   November 2, 2009
Updated :   December 15, 2013
latest changes: for the new downloader, removed jfDispButtonPanel, and heavily
updated jfLabeled Gauge
******************************************************************************/
#ifndef PPANEL_PARTS_H_INCLUDED
#define PPANEL_PARTS_H_INCLUDED
#endif // PPANEL_PARTS_H_INCLUDED
//-----------------------------------------
// For compilers that support precompilation, includes "wx/wx.h".
#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif
/*****************************************************************************/
/* wxGauge with label, counts, and label manipulation */
class jfLabeledGauge : public wxPanel {
  public:
    // the constructor
    jfLabeledGauge(wxWindow* parent, size_t bmheight, long style = wxTAB_TRAVERSAL, const wxString& name = wxT("jfLabeledGauge"));
    // setting data methods
    bool SetNew(int index_in, int tcx_in, wxString name=wxEmptyString);
    void ChangeAction(wxString action);
    bool SetDone(wxString action);
    bool SkipToDone(size_t skip_amount, wxString action, wxString name);
    bool SetCount(size_t newcount);
    void SetToZero(size_t newcount=0);
    void ChangeLabel(wxString inmsg);
    void ChangeTypestring(wxString intype, wxString saction_in);
    bool ChangeBarHeight(size_t bheight);
    bool ChangeFontSize(size_t psize);
    bool ChangeSizes(size_t bheight, size_t psize);
    bool RevertSizes();
    // getting info
    size_t GetIndex() const;
    size_t GetCount() const;
  protected:
    // helper methods
    wxString BuildMsg() const;
    // gui elements
    wxStaticText* main_label;
    wxGauge* prog_bar;
    wxBoxSizer* main_sizer;
    // counts
    size_t totalcount;
    size_t curpart, partsdone;
    int idx_curr, idx_total;
    // label info
    wxString ltype,laction;
    wxString saction;
    wxString pname;
    bool done;
    // other
    wxSize minsize;
    size_t bsize,fpsize;
};
/*****************************************************************************/
